/***********************************************************************
 * File: B.java
 * 	(Extracted from
 *	   "$Id: B.java,v 1.3 2004/06/12 17:41:39 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements an example of interupting to thread
 * and using StackTraceElement class that is provided from Java1.4.
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

public class B implements Runnable {
	public void run() {
		synchronized (this) {
			System.out.println("Child is waiting..."
							+ System.currentTimeMillis());
			try { wait();
			} catch (Exception e) {
				StackTraceElement[]	st = e.getStackTrace();
				System.out.println(e.getMessage());
				for (int i = 0; i < st.length; ++i) {
					System.out.println("[" + i + "] " + st[i] + "; "
										+ st[i].getMethodName()
										);
				}
			}
			System.out.println("Child wakes up!"
							+ System.currentTimeMillis());
		}
	}

	static void print_temp_exception() throws Exception {
		Exception e = new Exception();
		StackTraceElement[] ste = e.getStackTrace();
		for (int i = 0; i < ste.length; ++i) {
			System.out.println("[" + i + "] " + ste[i] + ";"
								+ ste[i].getClassName() + "."
								+ ste[i].getMethodName()
								);
		}
		if (e != null) {
			throw e;
		}
	}

	static public void main(String[] args) {
		Thread t = new Thread(new B());

		System.out.println("Parent starts child.");
		t.start();

		try { Thread.sleep(2000); } catch (Exception e) { ; }

		System.out.println("Parent interrupts to child.");
		t.interrupt();

		
		try { t.join(); } catch (Exception e) { ; }
		System.out.println("Parent joined child.");

		System.out.println("Parent prints template exception");
		try {
			print_temp_exception();
		} catch (Exception e) {	
			System.out.println("Parent catch temp-exception..." + e);
		}
	}
}
