/***********************************************************************
 * File: D.java
 * 	(Extracted from
 *	   "$Id: D.java,v 1.2 2004/06/12 17:42:16 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements an example using ObjectInputStream
 * and ObjectOutputStream classes.
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

import java.io.*;

public class D {
	static public long[] nums = { 2, 3, 5, 7, 11 };
	static public long[] restored = null;

	static void dump(String path) throws Exception {
		ObjectOutputStream oos = new ObjectOutputStream(
										new FileOutputStream(
												new File(path)
										));

		oos.writeInt(nums.length);
		oos.writeObject(nums);
		oos.close();

		for (int i = 0; i < nums.length; ++i) {
			System.out.print("["+i+"]="+nums[i]+" ");
		}
		System.out.println("");
	}

	static boolean restore(String path) throws Exception {
		boolean	result	=true;
		ObjectInputStream ois = new ObjectInputStream(
										new FileInputStream(
												new File(path)
										));

		int	length	= ois.readInt();
		restored	= (long[])ois.readObject();
		ois.close();

		System.out.println("restore("+path+"): length = "+length
								+", restored.length = "+restored.length
								);
		if (length != restored.length) {
			System.out.println("restore("+path+"): "
								+"differ array length!!!"
								);
			result	= false;
		}

		for (int i = 0; i < restored.length; ++i) {
			System.out.print("["+i+"]="+restored[i]+" ");
		}
		System.out.println("");

		return	result;
	}

	static public void main(String[] args) {
		if (args.length < 1 || args.length > 2) {
			System.out.println(
					"Usage: java D [dump|restore] backup-file-path"
					);
		}
		else {
			if (args.length == 1 || args[0].compareTo("dump") == 0) {
				try {
					dump(args[args.length - 1]);
				} catch (Exception e) {
					System.out.println("main("+args[0]+"): "
							+"dump() occures exception!\n"
							+e.getMessage()
							);
					e.printStackTrace();
				}
			}

			if (args.length == 1 || args[0].compareTo("restore") == 0) {
				try {
					restore(args[args.length - 1]);
				} catch (Exception e) {
					System.out.println("main("+args[0]+"): "
							+"restore() occures exception!\n"
							+e.getMessage()
							);
					e.printStackTrace();
				}
			}
		}
	}
}
