/***********************************************************************
 * File: LogTest.java
 * 	(Extracted from
 *	   "$Id: LogTest.java,v 1.4 2004/07/04 12:41:27 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a test program
 * for the "Log" and "LogResource" utility class.
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

import my_util.Log;
import my_util.LogConf;
import my_util.LogResource;

public class LogTest {
	static public void main(String[] args) {
		String path = "LogTest.log.txt";
		String file_encoding = (args.length == 0)? null: args[0];

		System.out.println("***LogResource.get_resource_cnt() is "
						+ LogResource.get_resource_cnt()
						);

		Log	log = new Log(new LogConf(
								"yyyyN MM dd HH mm  ss.SSSb"
								, Log.STDOUT
								, null
								, "--"
								, Log.INFO
						));

		System.out.println("***LogResource.get_resource_cnt() is "
						+ LogResource.get_resource_cnt()
						);
		if (!log.open()) {
			System.out.println("***LogResource.get_resource_cnt() is "
							+ LogResource.get_resource_cnt()
							);
			System.err.println("LogTest.main(): failed in log.open()");
		}
		else {
			System.out.println("***LogResource.get_resource_cnt() is "
							+ LogResource.get_resource_cnt()
							);
			for (int i = 0; i < 2; ++i) {
				System.out.print("LogTest.main(): "
									+ i + "-th loop.\n"
									);

				boolean registered;
				System.out.print("***LogResource.is_registered(" + path
								+ ") returns "
								+ (registered =
									LogResource.is_registered(path))
								+ ".\n"
								);
				if (registered) {
					System.out.print("***LogResource.get_encoding("
									+ path + ") returns "
									+ LogResource.get_encoding(path)
									+ ".\n"
									);
				}

				log.print(log.FATAL, "fatal message");
				log.print(log.ERROR, "error message");
				log.print(log.WARN, "waning message");
				log.print(log.INFO, "information message");
				log.print(log.FATAL, "vIȏꍇ̃OEbZ[W");

				System.out.println("***LogResource.get_resource_cnt() "
								+ "is " + LogResource.get_resource_cnt()
								);
				if (!log.change(new LogConf(
							"yyyy-MM-dd/HH:mm:ss.SSS 'JST'"
							, path
							, file_encoding
							, log.DEFAULT_DELIMIT
							, Log.ERROR
							))) {
					System.out.println("***LogResource.get_resource_cnt"
									+ "() is "
									+ LogResource.get_resource_cnt()
									);
					System.err.println("LogTest.main(): "
										+ "failed in log.change()"
										);
					break;
				}
			}

			System.out.println("***LogResource.get_resource_cnt() is "
							+ LogResource.get_resource_cnt()
							);
			log.close();

			System.out.println("***LogResource.get_resource_cnt() is "
							+ LogResource.get_resource_cnt()
							);
		}
	}
}
