/***********************************************************************
 * File: Table.java
 * 	(Extracted from
 *	   "$Id: Table.java,v 1.2 2004/05/24 12:30:06 maoyam Exp maoyam $")
 *
 * Abstracts:
 *   This Java source code implements the test program of
 * the sharable interface `my_util.Sharable'.
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

import	java.io.*;

public class Table implements my_util.Sharable {
	private	int				update_count	= -1;
	private	StringBuffer	name	= null;
	private	long			value	= -1;

	// Sharable interface needs to implement this method.
	public boolean initialize(String[] vals) {
		boolean	result	= false;
		try {
			int	vals_len = vals.length, i = 0;
			if (vals_len > i && vals[i] != null) {
				update_count	= Integer.parseInt(vals[i++]);
			}

			if (vals_len > i && vals[i] != null) {
				name	= new StringBuffer(vals[i++]);
			}

			if (vals_len > i && vals[i] != null) {
				value	= Long.parseLong(vals[i++]);
			}

			result	= true;
		} catch (Exception e) {
			SharedObjectTest.print_exception(e);
		}

		return	result;
	}

	public void update() {
		++update_count;
		name.append("a");
		value += 2;
	}

	public void print_vals() {
		System.out.print("--- Table object (" + this.hashCode()
						+ ")\n" 
						+ "\tupdate_count = " + update_count + "\n"
						+ "\tname is \"" + name + "\"\n"
						+ "\tvalue = " + value + "\n"
						+ "----------------------------------\n"
						);
	}
}
