/***********************************************************************
 * File: TimerTest.java
 * 	(Extracted from
 *	   "$Id: TimerTest.java,v 1.6 2004/07/04 12:42:19 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a test program for TimerUser, Timer
 * and TimerCommand classes.
 *  (Refer Classes: TimerUser, Timer, TimerCommand)
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

import my_util.Application;
import my_util.FacilityConf;
import my_util.LogConf;
import my_util.Log;

// ^C}@\IђPIɎgpQ̋@\sA
// CXyN^@\񋟂AvP[V̗B
// R}hŁAAvP[VI܂ł̎Ԃ~bxŎw
// łBAvP[VIԂw肵ȂꍇAPVb
// AvP[V͏IB
public class TimerTest {

	// @\̍\`
	//   fac_confs[0] ́uI^C}gp (PERIODIC)vs@\
	//   fac_confs[1] ́uPI^C}gp (ONCE TIMER)vs@\
	// @\ꂼ̍\͈ȉ̒ʂBڍׂ my_util.Facility 
	// QƂ̂
	//   @\́A@\ Java NXA@\̍őXbhA
	//   @\Xbh̏lA@\Oo͐\A
	//   @\OtEtH[}bgEp^[A@\Oo͐pXA
	//   @\Oo͕GR[fBOA
	//   @\OEtB[h؂蕶A@\OExA
	//   @\Xbh̉L[
	static FacilityConf[] fac_confs = {
				  new FacilityConf("PERIODIC TIMER USER" // I^C}
								, "TimerUserTest"
								, 1
								, 1
								, null
								, Log.STDOUT
								, null
								, Log.DEFAULT_DELIMIT
								, Log.DEBUG
								, 1
								)
				, new FacilityConf("ONCE TIMER USER" // PI^C}
								, "TimerUserTest_once"
								, 1
								, 1
								, null
								, Log.STDOUT
								, null
								, Log.DEFAULT_DELIMIT
								, Log.DEBUG
								, 1
								)
			};

	// ^C}@\ƃCXyN^@\̃Oo͍\`B
	// Œ` fac_confs[] Ɠo͐w肵Ă
	static private LogConf log_conf = new LogConf(null
												, Log.STDOUT
												, null
												, Log.DEFAULT_DELIMIT
												, Log.DEBUG
												);

	// AvP[ṼvOEGg
	// gp@:
	//    java TimerTest [stop-interval]
	//      * stop-interval -- interval to stop this application (msec)
	//                         if this isn't specified, this application
	//                       should stop after 17secs.
	static public void main(String[] args) {
		// vOJnbZ[W\
		System.out.println("TimerTest.main("+ args + "): starts.");

		// AvP[V𐶐
		// CXyN^@\̑҂󂯃|[gԍ 8900
		Application app = new Application("TimerTest"
											, fac_confs
											, true
											, 8900 // inspector port
											, log_conf
											);

		try {
			app.start(); // AvP[VN

			// R}h̉߁Bw肪Ȃ΁AAvP[V
			// I܂ł̃C^[oPVbƂ
			long halt_intervals = ((args.length == 1)?
										Long.parseLong(args[0]):
										17000
										);

			// AvP[VI܂ł̃C^[oԂbŕ\
			System.out.println("TimerTest.main(" + args
								+ "): sleeps for "
								+ (halt_intervals / 1000) + " secs..."
								);

			// AvP[VIC^[oԂ܂ŁA
			// CEXbhx~
			try {
				Thread.sleep(halt_intervals);
			} catch (Exception e) { ; }

			// AvP[VIC^[oԂo߂Ƃ\
			System.out.println("TimerTest.main(" + args
								+ "): wakes up!"
								);

			app.stop(); // AvP[V~
		} catch (Exception e) {
			// Ȃ炩̗OꍇA̓e
			// X^bNEg[X܂߂ĕ\
			System.out.println("TimerTest.main(" + args
							+ "): Ocuures Exception \"" + e.getMessage()
							+ "\""
							);
			e.printStackTrace();
		}

		// vȌI\
		System.out.println("TimerTest.main("+ args + "): ends.");
	}
}
