/***********************************************************************
 * File: Application.java
 * 	(Extracted from
 *	   "$Id: Application.java,v 1.6 2004/07/04 13:04:05 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a Application utility class.
 *  This start and stop the facilities those are owned by application.
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package my_util;

import java.net.*;

import my_util.InspectionData;

/**
 * <p><em>AvP[V</em>`܂B<em>@\</em>̍\w
 * 󂯂AJnEI܂B܂A<em>@\</em>Ƀ^C}@\
 * 񋟂邩ۂɂĂwł܂B</p>
 *
 * @author maoyam
 * @version 1.0
 * @see FacilityConf
 * @see Timer
 * @see Facility
 * @see FacilityAgent
 */
public class Application implements Inspectable {

	// Runtime reference
	private Runtime rt = Runtime.getRuntime();

	/**
	 * <em>AvP[V</em>̃T}Ԃ܂B
	 * Inspectable C^tF[Xɂ邱ƂvĂ܂B
	 * @return <em>AvP[V</em>̃T}
	 */
	public InspectionData get_summary() {
		InspectionData	summary = new InspectionData();
		synchronized (this) {
			summary.add("", name);
			try { summary.add("IP AhX"
							, InetAddress.getLocalHost().toString()); 
				} catch (Exception e) { ; /* Ignore any exception */ }
			summary.add("N"
						, ((started_time == -1)?
							"":
							Utillity.format_milli_sec(null
													, started_time
													).toString()
						));
			summary.add("oߎ"
						, ((started_time == -1)?
							"":
							Utillity.format_elapsed_milli_sec(null
										, System.currentTimeMillis()
														- started_time
										).toString()
						));
			summary.add("", ((status == INIT)?			"":
									(status == STARTED)?	"쒆":
															"I"
						));
			summary.add("^C}@\"
						, ((timer == null)?			"":
							((timer_thr == null)?	"~":
													"N"
						)));
			summary.add("CXyN^"
						, ((inspector == null)?			"":
							((inspector_thr == null)?	"~":
														"N"
						)));
			summary.add("@\"
						, ((fac_confs != null)?
							Integer.toString(fac_confs.length, 10):
							"0"
						));
			if (rt != null) {
				InspectionData id = new InspectionData();
				id.add("e", Long.toString(rt.totalMemory(), 10));
				id.add("󂫃"
								, Long.toString(rt.freeMemory(), 10));
				id.add("őls"
								, Long.toString(rt.maxMemory(), 10));
				summary.add("Java ", id);
			}
			else {
				summary.add("Java ", "s");
			}
		} // synchornized(this)

		return	summary; // returns summary information about application
	}

	// format the detail informations about a fac_conf[] element
	// @param i index of fac_confs[] array
	// @return the details about the fac_conf[] element
	private InspectionData make_fac_conf_datums(int i) {
		InspectionData id = new InspectionData();
		FacilityConf fc = fac_confs[i];
		id.add("", fc.getName());
		id.add("NX", fc.getAgclass_name());
		id.add("@\CX^X", facs[i].toString());
		id.add("ő啽sx", Integer.toString(fc.getMax_concurrency()
												, 10
												));
		id.add("݂̕sx", Integer.toString(fc.getConcurrency()
												, 10
												));
		id.add("L[", Integer.toString(fc.getResq_len(), 10));
		id.add("Oo͐pX", fc.getLog_path());
		id.add("Oo̓x", Integer.toString(fc.getLog_level()
													, 10
													));
		id.add("Oo͕GR[fBO", fc.getLog_encoding());
		id.add("OEtB[h؂蕶", fc.getLog_delimit());

		return id; // returns the details of the FacilityConf
	}

	/**
	 * <em>AvP[V</em>̏ڍ׏Ԃ܂B
	 * Inspectable C^tF[Xɂ邱ƂvĂ܂B
	 * @return <em>AvP[V</em>̏ڍ׏
	 */
	public InspectionData get_details() {
		InspectionData	details = new InspectionData();
		InspectionData	values = null;
		synchronized (this) {
			values = new InspectionData();
			values.add("CX^X"
							, ((timer != null)?
											timer.toString():
											""
							));
			values.add("Xbh"
							, ((timer_thr != null)?
									timer_thr.toString():
									""
							));
			values.add("Oo͐", timer.get_log());
			values.add("Oo͐pX", timer.get_log_path());
			values.add("Oo͕GR[fBO"
						, timer.get_log_encoding()
						);
			values.add("OEtB[h؂蕶"
						, timer.get_log_delimit()
						);
			values.add("OEx"
						, Integer.toString(timer.get_log_level(), 10)
						);
			details.add("^C}", values);

			values = new InspectionData();
			values.add("CX^X"
							, ((inspector != null)?
									inspector.toString():
									""
							));
			values.add("Xbh"
							, ((inspector_thr != null)?
									inspector_thr.toString():
									""
							));
			values.add("ڑҎ TCP |[g"
							, ((inspector != null)?
								Integer.toString(inspector_port, 10):
								""
							));
			values.add("Oo͐", inspector.get_log());
			values.add("Oo͐pX", inspector.get_log_path());
			values.add("Oo͕GR[fBO"
						, inspector.get_log_encoding()
						);
			values.add("OEtB[h؂蕶"
						, inspector.get_log_delimit()
						);
			values.add("OEx"
						, Integer.toString(inspector.get_log_level()
											, 10)
						);
			details.add("CXyN^", values);

			if (fac_confs != null) {
				for (int i = 0; i < fac_confs.length; ++i) {
					if (fac_confs[i] != null) {
						details.add("@\\ [" + (i + 1) + "]"
									, make_fac_conf_datums(i)
									);
					}
					else {
						details.add("@\\ [" + (i + 1) + "]", "");
					}
				}
			}
			else {
				details.add("@\\", "w");
			}
		} // synchornized(this)

		return	details; // returns detail informations about this
	}

	// name of this application
	private String name = null;

	// time stump of started and stopped this application
	private long started_time	= -1;
	private long stopped_time	= -1;

	/**
	 * <em>AvP[V</em>̖̂擾܂
	 * @return <em>AvP[V</em>̖
	 */
	public String get_name() { synchronized (this) { return name; } }

	// status of application
	static final private int INIT = 0; // Initialized
	static final private int STARTED = 1; // started all facilities
	static final private int STOPPED = 2; // stopped all facilities
	private int status = INIT;

	// arrays of the facilities
	private Facility[] facs = null;
	// arrays of the facility configurations
	private FacilityConf[] fac_confs = null;

	/**
	 * <em>AvP[V</em><em>@\</em>\z擾
	 * ܂
	 * @return <em>AvP[V</em><em>@\</em>\z
	 */
	public FacilityConf[] get_fac_confs() {
		synchronized (this) { return fac_confs; }
	}

	// thread running the timer
	private Thread timer_thr = null;
	// application timer
	private Timer timer	= null;

	/**
	 * <em>AvP[V</em><em>@\</em>ɒ񋟂^C}擾
	 * ܂
	 * @return <ul><li> null -- <em>AvP[V</em><em
	 *                            >@\</em>ɒ񋟂^C}</li
	 *            ><li>null -- ^C}񋟂ĂȂꍇ</li
	 *            ></ul>
	 */
	protected Timer get_app_timer() {
		synchronized (this) { return timer; }
	}

	// thread running the inspector
	private Thread inspector_thr = null;
	// the inspector of this application
	private Inspector inspector = null;
	// the port number of inspector accepting
	private int inspector_port = Inspector.NOT_PROVIDED;

	/**
	 * RXgN^: <em>AvP[V</em>̖́A<em>@\</em
	 * >\ă^C}񋟂̉ۂwł܂
	 *
	 * @param name <em>AvP[V</em>
	 * @param fac_confs <em>@\</em>\̔z
	 * @param use_timer ^C}@\񋟂̉
	 * @param inspector_port <em>CXyN^</em>̑҂󂯃|[gԍ
	 * @param log_conf ^C}<em>CXyN^</em
	 *                 >̃Oo͐\B
	 *                 my_util.LogConf QƂ̂
	 */
	public Application(String name
						, FacilityConf[] fac_confs
						, boolean use_timer
						, int inspector_port
						, LogConf log_conf
						) {
		this.name	= name;
		this.fac_confs	= fac_confs;
		if (use_timer) {
			// construct the application timer (not running)
			timer	= new Timer(log_conf);
		}
		if (inspector_port != Inspector.NOT_PROVIDED) {
			// construct the apllication inspector
			this.inspector_port	= inspector_port;
			inspector = new Inspector(this
										, inspector_port
										, log_conf
										);
		}
		status	= INIT;
	}

	/**
	 * ^C}̃Oo͐EGR[fBOEtB[h؂蕶E
	 * O擾xύX܂
	 *
	 * @param log_conf Oo͐\Bmy_util.LogConf QƂ̂
	 * @return <ul><li>true -- ^C}@\̃Oo͐؂ւɐ
	 *                         ꍇ</li
	 *            ><li>false -- ؂ւɎsꍇ</li
	 *            ></ul>
	 * @exception Exception Timer  change_log \bhQƂ̂
	 */
	public boolean change_timer_log(LogConf log_conf) throws Exception {
		boolean	result = false;
		synchronized (this) {
			result = timer.change_log(log_conf);
		}

		return	result;
	}

	/**
	 * CXyN^̃Oo͐EGR[fBOEtB[h؂
	 * EO擾xύX܂
	 *
	 * @param log_conf Oo͍\BLogConf QƂ̂ƁB
	 * @return <ul><li>true -- CXyN^@\̃Oo͐؂ւ
	 *                         ꍇ</li
	 *            ><li>false -- ؂ւɎsꍇ</li
	 *            ></ul>
	 * @exception Exception Inspector  change_log \bhQƂ̂
	 */
	public boolean change_inspector_log(LogConf log_conf)
											throws Exception {
		boolean	result = false;
		synchronized (this) {
			result = inspector.change_log(log_conf);
		}

		return	result;
	}

	// halt the timer
	// @exception Exception see the Timer.halt() method
	private void halt_timer() throws Exception {
		// if the timer is running...
		if (timer != null && timer_thr != null) {
			timer.halt(); // halt the timer
			timer_thr.join(); // join the timer thread
		}
	}

	/**
	 * <em>AvP[V</em>\@\ׂ̂ĂJn܂
	 * @return Jn<em>@\</em>
	 * @exception Exception 1) ^C}̐Ɏsꍇ
	 *                      2) ꂩ Facility ̐Ɏsꍇ
	 *                      3) ꂩ Facility ̊Ɏs
	 *                         ꍇ
	 */
	public int start() throws Exception {
		// check this application has no facility?
		if (fac_confs == null || fac_confs.length == 0) {
			return	0; // returns 0 facility
		}

		// check this application had started all facilities, yet?
		if (status == STARTED) {
			return	facs.length; // returns number of facilities
		}

		// check the timer is exist?
		if (timer != null) {
			// start the timer thread
			timer_thr = new Thread(timer);
			if (timer_thr == null) {
				// Failed to construct the timer thread!
				throw new Exception("Application.start(): "
							+ "can't construct timer_thr for timer "
							+ "(" + timer + ")"
							);
			}
			timer_thr.start(); // start the thread
		}

		// construct the array of facilities
		facs	= new Facility[fac_confs.length];

		// construct the all facilities...
		for (int i = 0; i < facs.length; ++i) {
			facs[i]	= Facility.create(fac_confs[i].getName()
									, fac_confs[i].getAgclass_name()
									, fac_confs[i].getMax_concurrency()
									, fac_confs[i].getConcurrency()
									, new LogConf(
											  fac_confs[i]
													.getLog_df_pattern()
											, fac_confs[i]
													.getLog_path()
											, fac_confs[i]
													.getLog_encoding()
											, fac_confs[i]
													.getLog_delimit()
											, fac_confs[i]
													.getLog_level()
											)
									, fac_confs[i].getResq_len()
									);
			if (facs[i] == null) {
				// Failed to construct a facility!
				halt_timer(); // halt the running timer and thread

				throw new Exception("Application.start(): "
							+ "can't create the "+ i
							+ "-th facility configuration { "
							+ fac_confs[i].getName() + ", "
							+ fac_confs[i].getAgclass_name() + "}"
							); 
			}
			facs[i].set_app(this); // set this application to fac
		}

		// activate all facilities...
		for (int i = 0; i < facs.length; ++i) {
			if (facs[i].activate() == false) {
				// Failed to activate a facility!
				halt_timer(); // halt the running timer and thread

				// deactivate the running facilities...
				for (int j = 0
				; j < facs.length && facs[j] != null
				; ++j) {
					facs[j].deactivate();
				}

				throw new Exception("Application.start(): "
							+ "can't activate the " + i
							+ "-th facility configuration { "
							+ fac_confs[i].getName() + ", "
							+ fac_confs[i].getAgclass_name() + "}"
							);
			}
		}

		// set this application status to STARTED
		status	= STARTED;
		started_time	= System.currentTimeMillis();

		// check the application inspector is acceptable?
		if (inspector != null) {
			// generate a thread running inspector, and start it
			inspector_thr = new Thread(inspector);
			inspector_thr.start();
		}

		return facs.length; // returns the number of started facilities
	}

	/**
	 * <em>AvP[V</em>JnĂ<em>@\</em>ׂ̂Ă
	 * ~܂B
	 *
	 * @return ~<em>@\</em>
	 * @exception Exception Facility  deactivate \bhQƂ̂
	 */
	public int stop() throws Exception {
		// check this application has no facility?
		if (facs == null || facs.length == 0) {
			return	0; // returns 0 facility
		}
		// check this application had stopped all facilities, yet?
		if (status == STOPPED) {
			return	facs.length; // returns the number of facilities
		}

		// halt the running timer and thread
		halt_timer();

		// deactivate all facilities...
		for (int i = 0; i < facs.length; ++i) {
			facs[i].deactivate();
		}

		// set this application status to STOPPED
		status	= STOPPED;
		stopped_time	= System.currentTimeMillis();

		// check the application inspector is acceptable?
		if (inspector != null) {
			// stop the thread running inspector, and join it
			inspector.stop();
			inspector_thr.join();
		}

		return facs.length; // returns the number of stopped facilities
	}
}
