/***********************************************************************
 * File: Cmp.java
 * 	(Extracted from
 *	   "$Id: Cmp.java,v 1.1 2004/06/28 14:50:24 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a Cmp utility tool.
 *  This tool compares two files (size and contents).
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package my_util;

import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.channels.*;

/**
 * <p>Q̃t@Crc[łB</p>
 * <p>java my_util.Cmp file1 file2</p>
 * <p>t@C̃TCYقȂ邩eɑႪꍇɃbZ[W
 *    o͂܂</p>
 */
public class Cmp {

	/** IR[h: t@CeɑႪȂƂ܂ */
	static final public int Files_Are_Same		= 0;
	/** IR[h: t@CeɑႪ邱Ƃ܂ */
	static final public int Files_Are_Not_Same	= 1;
	/** IR[h: t@Cw肪邩Ȃꍇ */
	static final public int Usage_Error			= 2;
	/** IR[h: wpXǂݍ݉\ȃt@CłȂꍇ */
	static final public int Not_Readable_File	= 3;
	/** IR[h: O𒆒fꍇ */
	static final public int Occured_Exception	= 4;

	/**
	 * vOGg
	 * @param args r2̃t@C̃pX
	 */
	static public void main(String[] args) {
		if (args.length != 2) {
			System.err.println(
					"Usage: java my_util.Cmp file1 file2"
				);
			System.exit(Usage_Error);
		}

		int exit_code = Files_Are_Not_Same;
		try {
			try {
				if (Utillity.equals_file_contents(args[0], args[1])) {
					exit_code = Files_Are_Same;
				}
				else {
					System.out.println("\"" + args[0]
										+ "\" isn't equals to\""
										+ args[1] + "\"."
										);
					exit_code = Files_Are_Not_Same;
				}
			} catch (IllegalArgumentException e) {
				System.err.print(e.getMessage());
				System.exit(Not_Readable_File);
			}
		} catch (Exception e) {
			System.err.print(e.getMessage() + " {"
						+ Utillity.format_exception_info(null, e) + "}"
						);
			exit_code	= Occured_Exception;
		}

		System.exit(exit_code);
	}
}
