/***********************************************************************
 * File: FacilityAgent.java (abstract)
 * 	(Extracted from
 *	 "$Id: FacilityAgent.java,v 1.16 2004/07/04 02:28:22 maoyam Exp maoyam $)
 *
 * Abstracts:
 *   This Java source code implements the agent utility abstract class.
 *   (Refered class: "Facility" class)
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package	my_util;

import	my_util.Utillity;

/**
 * <p><em>AvP[V</em>\<em>@\</em>\
 *    Facility NXɂ萧䂳<em>@\</em>
 *    ߂̒ۃNXłB̃NX̃CX^X́AFacility 
 *    쐬ꂽXbhŎs܂B</p>
 *
 * <p> Facility ɑMvR}h̉M邽߂
 *    L[܂B</p>
 *
 * <p><em>@\</em>ɂ́ÃNXgȉ
 *    ۃ\bh`Kv܂B</p>
 *
 * <ul><li>init()</li
 *    ><li>process()</li
 *    ><li>suspend()</li
 *    ><li>resume()</li
 *    ><li>terminate()</li
 *    ></ul>
 *
 * <p>init() ́A<em>@\</em>ꂽꍇɁAs
 *    ߂ɌĂяo܂B</p>
 * <p>process() ́A<em>@\</em>̗vL[ FacilityComannd 
 *    MꂽꍇɌĂяo܂B</p>
 * <p>suspend() ́A<em>@\</em>̕sxꍇɁA 
 *    FacilityAgent ̃Xbh𒆒f邽߂ɌĂяo܂B
 *    ȍ~A resume() Ăяo邩 terminate() Ăяo
 *    ܂ŒfԂ͌p܂B</p>
 * <p>resume() ́A<em>@\</em>̕sxオꍇɒfԂ
 *    A邽߂ɌĂяo܂B</p>
 * <p>terminate() ́A<em>@\</em>񊈐ɂꂽꍇɁAI
 *    s߂ɌĂяo܂B</p>
 * <p>̃\bhُIꍇAɂ FacilityAgent 
 *    Xbh͒~܂B܂AݗO InterruptedException 
 *    邢 process() ^CAEgO TimeoutException  throw
 *    ꍇɂA FacilityAgent ̃Xbh͂ɒ~܂B
 *    ̍ہAOo͐ FATAL OEx̃bZ[Wo͂܂B
 * </p>
 *
 * @author maoyam
 * @version 1.0
 * @see Facility
 * @see FacilityAgentControlBlock
 * @see Message
 * @see Log
 * @see Loggable
 */
abstract public class FacilityAgent implements Runnable {

	/**
	 * 邽߂̒ۃ\bhłB
	 * <em>@\</em>ꂽꍇɌĂяo܂B
	 *
	 * @return <ul><li>true -- ɐꍇ</li
	 *            ><li>false -- ɎsꍇB^[A
	 *                           FacilityAgent ̃Xbh͒~
	 *                          ܂B</li
	 *            ></ul>
	 * @exception InterruptedException Ɋ݂
	 *                                 ꍇB FacilityAgent 
	 *                                 Xbh͒~܂B
	 * @exception Exception Ɋ݈ȊO̗O
	 *                      ꍇA FacilityAgent ̃Xbh
	 *                      terminate() Ăяoɒ~܂B
	 */
	abstract public boolean init() throws Exception;

	/**
	 * f邽߂̒ۃ\bhłB
	 * <em>@\</em>̕sxꂽꍇɌĂяo܂B
	 *
	 * @return <ul><li>true -- fɐꍇ</li
	 *            ><li>false -- fɎsꍇB^[A
	 *                          terminate() Ăяo܂B</li
	 *            ></ul>
	 * @exception InterruptedException fɊ݂
	 *                                 ꍇB FacilityAgent 
	 *                                 Xbh͒~܂B
	 * @exception Exception fɊ݈ȊO̗O
	 *                      ꍇA FacilityAgent ̃Xbh
	 *                      terminate() ĂяoĒ~܂B
	 */
	abstract public boolean suspend() throws Exception;

	/**
	 * fԂ̕A邽߂̒ۃ\bhłB
	 * <em>@\</em>̕sxグꂽ΂ɌĂяo܂B
	 *
	 * @return <ul><li>true -- Aɐꍇ</li
	 *            ><li>false -- AɎsꍇB^[A
	 *                          terminate() Ăяo܂B</li
	 *            ></ul>
	 * @exception InterruptedException AɊ݂
	 *                                 ꍇB FacilityAgent 
	 *                                 Xbh͒~܂B
	 * @exception Exception AɊ݈ȊO̗O
	 *                      ꍇA FacilityAgent ̃Xbh
	 *                      terminate() ĂяoĒ~܂B
	 */
	abstract public boolean resume() throws Exception;

	/**
	 * vR}h邽߂̒ۃ\bhłB
	 * <em>@\</em>̗vL[M FacilityCommand 
	 * n܂B
	 *
	 * @return <ul><li>{@link #NORMALEND} -- vR}hɐ
	 *                                       ꍇ</li
	 *            ><li>1 ȏ̐ -- vR}hɎsꍇB
	 *                                 ^[Aterminate() 
	 *                                 Ăяo܂B</li
	 *            ></ul>
	 * @exception TimeoutException vR}hɃ^CAEg
	 *                             ꍇB FacilityAgent 
	 *                             Xbh͒~܂B
	 * @exception InterruptedException vR}hɊ݂
	 *                                 ꍇB FacilityAgent 
	 *                                 Xbh͒~܂B
	 * @exception Exception vR}hɃ^CAEg܂͊
	 *                      ȊO̗OꍇA FacilityAgent
	 *                      ̃Xbh terminate() ĂяoĒ~
	 *                      ܂B
	 */
	abstract public int process(FacilityCommand req)
									throws Exception;
					// "process()" must return 0 or positive integer!

	/**
	 * ~邽߂̒ۃ\bhłB
	 * <em>@\</em>̔񊈐ꂽꍇAprocess(), suspend(),
	 * resume() ُIꍇ邢̓^CAEgE݈ȊO̗O
	 * 𓊂ꍇɌĂяo܂B
	 *
	 * @return <ul><li>true -- ~ɐꍇ</li
	 *            ><li>false -- ~ɎsꍇB</li
	 *            ></ul>
	 * @exception Exception ~ɗOꍇB
	 */
	abstract public boolean terminate() throws Exception;

	private String	facname = ""; // facility-name
	private	int	aid = -1;	// agent-ID
	private	String	agname	= null;	// agent-name

	/** <em>@\</em>̂ݒ肷 */
	public void setFacname(String facname) { this.facname = facname; }
	/** <em>@\</em>̂擾 */
	public String getFacname() { return facname; }
	/** G[WFg ID ݒ肷 */
	public void setAid(int aid) { this.aid = aid; }
	/** G[WFg ID 擾 */
	public int getAid() { return aid; }
	/** G[WFĝݒ肷 */
	public void setAgname(String agname) { this.agname = agname; }
	/** G[WFĝ擾 */
	public String getAgname() { return agname; }

	/** Ōɓo͂sIuWFNg */
	protected Object	wait_channel = null;

	/** ŌɎMvR}h */
	protected FacilityCommand	last_command = null;

	/** I */
	static final protected int NORMALEND						= 0;
	/** G[: sȏԂŃXbhs (start()) ꂽꍇ */
	static final protected int ILLEGAL_STATUS					= -1;
	/** G[: init() ُIꍇ */
	static final protected int INIT_RETURNED_FALSE				= -2;
	/** G[: tF[YŗOꍇ */
	static final protected int EXCEPTION_IN_INIT_PHASE			= -3;
	/** G[: ݌̎擾ɗOꍇ */
	static final protected int EXCEPTION_IN_GET_INTERRUPT_CAUSE	= -4;
	/** G[: <em>@\</em>̕sx̎擾ɗOꍇ */
	static final protected int EXCEPTION_IN_GET_NOW_CONCURRENCY	= -5;
	/** G[: suspen() ُIꍇ */
	static final protected int SUSPEND_RETURNS_FALSE			= -6;
	/** G[: ftF[YŗOꍇ */
	static final protected int EXCEPTION_IN_SUSPEND				= -7;
	/** G[: resume() ُIꍇ */
	static final protected int RESUME_RETURNS_FALSE				= -8;
	/** G[: AtF[YŗOꍇ */
	static final protected int EXCEPTION_IN_RESUME				= -9;
	/** G[: vL[̃R}hMُIꍇ */
	static final protected int GET_REQUEST_RETURNED_NULL		= -10;
	/** G[: v擾tF[YŗOꍇ */
	static final protected int EXCEPTION_IN_GET_REQUEST			= -11;
	/** G[: vtF[YŃ^CAEgOꍇ */
	static final protected int TIMEOUTED_IN_PROCESS				= -12;
	/** G[: vtF[YŗOꍇ */
	static final protected int EXCEPTION_IN_PROCESS				= -13;
	/** G[: terminate() ُIꍇ */
	static final protected int TERMINATE_RETURNED_FALSE			= -14;
	/** G[: ~tF[YŗOꍇ */
	static final protected int EXCEPTION_IN_TERMINATE			= -15;
	/** G[: ItF[YŗOꍇ */
	static final protected int EXCEPTION_IN_ZOMBINATE			= -16;
	/**
	 * ~̌G[R[hB
	 * I 0 At[[NɃG[ꍇ͕A
	 * process() ۃ\bhُIꍇ 1 ُ̐ƂȂB
	 */
	protected int[] halt_cause = { NORMALEND, NORMALEND };
	/** ~̌ƂȂOB */
	protected Exception[] fatal_exception = { null, null };
	/** ~̗O̐ */
	protected int fatal_exception_cnt = 0;

	/**
	 *  Facility ֑MvR}h̉󂯕t鉞L[
	 */
	protected Message resq = null;

	/** RXgN^ */
	protected FacilityAgent() {}

	/**
	 * ̃G[WFgML[ {@link #resq} 쐬
	 *
	 * @param resq_len L[̒
	 */
	protected void create_resq(int resq_len) {
		resq = Message.create(Thread.currentThread(), agname, resq_len);
	}

	/**
	 * ̃G[WFgML[ {@link #resq} j
	 */
	protected void destroy_resq() {
		// check existance of the responce-queue
		if (resq != null) {
			// destroy the responce-queue
			Message.destroy(Thread.currentThread(), agname);
			resq	= null;
		}
	}

	// get the interrupt-cause
	// @exception Exception 1) Failed to get the FACB.
	//                      2) The FACB isn't exist.
	//                      3) Failed to lock or unlock the FACB.
	private int get_interrupt_cause() throws Exception {
		boolean	r, rr;
		int	result = FacilityAgentControlBlock.NOTHING;
		SharedObject	facbso = null;
		FacilityAgentControlBlock	facb = null;

		// lock the FACB (sharing,blocking infinite)
		r = rr = false;
		facbso = SharedObject.attach(agname);
		if ((facbso != null)
		&& (r = facbso.take(true, true, 0)) == true) {
			try {
				// get the FACB
				facb = (FacilityAgentControlBlock)(facbso.get_object());
			} catch (Exception e) {
				// Occures exception!
				rr	= facbso.leave(); // unlock the FACB
				throw e;
			}

			// check existance of the FACB
			if (facb == null) {
				// The FACB isn't exist!
				rr = facbso.leave(); // unlock the FACB
				throw new Exception("FacilityAgent.get_interrupt_cause"
									+ "(): facb is null."
									);
			}

			result	= facb.interrupt_cause; // get the interrupt-cause

			rr	= facbso.leave(); // unlock the FACB
		}
		if (!r || !rr) {
			// Failed to lock or unlock the FACB!
			throw new Exception("FacilityAgent.get_interrupt_cause(): "
								+ "facbso." + ((!r)? "take": "leave")
								+ "() returns false."
								);
		}

		return	result; // returns the interrupt-cause
	}

	// set the agent status
	// @param status the destiny status
	// @param timeout specify the time-out interval (msec)
	// @exception Exception 1) the FACB isn't exist.i
	//                      2) Failed to loc or unlock the FACB.
	private void set_status(int status, long timeout) throws Exception {
		boolean	r, rr;
		SharedObject	facbso = null;
		FacilityAgentControlBlock	facb = null;

		// lock the FACB (sharing, blocking until timeout)
		r = rr = false;
		facbso = SharedObject.attach(agname);
		if ((facbso != null)
		&& (r = facbso.take(true, true, timeout)) == true) {
			try {
				// get the FACB
				facb = (FacilityAgentControlBlock)(facbso.get_object());
			} catch (Exception e) {
				// Failed to get the FACB!
				rr	= facbso.leave(); // unlock the FACB
				throw e;
			}

			if (facb != null) {
				facb.status	= status; // set the agent status
			}
			else {
				// The FACB isn't exist!
				throw new Exception("FacilityAgent.set_status("
									+ status + ", " + timeout
									+ "): facb is null."
									);
			}

			rr	= facbso.leave(); // unlock the FACB
		}
		if (!r || !rr) {
			// Failed to lock or unlock the FACB!
			throw new Exception("FacilityAgent.set_status("
								+ status + ", " + timeout
								+ "): facbso." + ((!r)? "take": "leave")
								+ "() returns false."
								);
		}
	}
		
	// get the agent status
	// @param timeout specify the timeout interval (msec)
	// @exception Exception 1) Failed to get the FACB.
	//                      2) The FACB isn't exist.
	//                      3) Failed to lock or unlock the FACB.
	private int get_status(long timeout) throws Exception {
		boolean	r, rr;
		int	result = FacilityAgentControlBlock.NONE;
		SharedObject	facbso = null;
		FacilityAgentControlBlock	facb = null;

		// lock the FACB (monopolize, blocking until timeout)
		r = rr = false;
		facbso = SharedObject.attach(agname);
		if ((facbso != null)
		&& (r = facbso.take(false, true, timeout)) == true) {
			try {
				// get the FACB
				facb = (FacilityAgentControlBlock)(facbso.get_object());
			} catch (Exception e) {
				// Failed to get the FACB!
				rr	=facbso.leave(); // unlock the FACB
				throw e;
			}

			if (facb != null) {
				result	= facb.status; // get the agent status
			}
			else {
				// The FACB isn't exist!
				throw new Exception("FacilityAgent.get_status("
									+ timeout + "): facb is null."
									);
			}

			rr	= facbso.leave(); // unlock the FACB
		}
		if (!r || !rr) {
			// Failed to lock or unlock the FACB!
			throw new Exception("FacilityAgent.get_status(" + timeout
								+ "): facbso." + ((!r)? "take": "leave")
								+ "() returns false."
								);
		}

		return	result; // returns the agent status
	}

	// Recieve the FacilityCommand from the Facility request-queue
	// @param timeout specify the timeout interval (msec)
	// @exception Exception 1) The facility isn't exist.
	//                      2) Failed to lock or unlock the facility.
	//                      3) The facility request-queue isn't exist.
	private FacilityCommand get_request(long timeout) throws Exception {
		long start_millis = System.currentTimeMillis(), tto = timeout;
		boolean	r = false, rr = false;
		Facility	fac = null;
		Message	reqq	= null;
		FacilityCommand	result = null;

		// search the facility
		fac	= Facility.attach(facname);
		if (fac == null) {
			// The facility isn't exist!
			throw new Exception("FasilityAgent.get_request(" + timeout
								+ "): " + facname + " isn't exist."
								);
		}

		// lock the facility (sharing, blocking until timeout)
		tto	= Utillity.check_timeout(start_millis, timeout);
		if ((r = fac.take(true, true, tto)) == true) {
			reqq	= fac.req_queue; // get the facility responce-queue

			rr	= fac.leave(); // unlock the facility
		}
		if (!r || !rr) {
			// Failed to lock or unlock the facility!
			throw new Exception("FasilityAgent.get_request(" + timeout
								+ "): fac." + ((!r)? "take": "leave")
								+ "() returns false."
								);
		}
		if (reqq == null) {
			// The facility responce-queue isn't exist!
			throw new Exception("FasilityAgent.get_request(" + timeout
								+ "): request queue is null."
								);
		}

		// set the wait channel for Inspector
		wait_channel = reqq;

		// Wait to arrive the request...until timeout
		tto	= Utillity.check_timeout(start_millis, timeout);
		result	= (FacilityCommand)(reqq.get(true, true, tto));

		// If the request is arrived...
		if (result != null) {
			// set the processing-status to the request-command
			result.setStatus(result.PROCESSING);
			// set this agent-name to the request command
			result.setProcessing_agent(agname);
		}

		return	result; // returns null: the request-queue is destroyed
						// returns not-null: the reuest command
	}

	/**
	 * vR}hŎꂽ̃L[ɁǍʂ𑗐M܂B
	 *
	 * @param buf R}hBFaclityCommand ł邱ƁB
	 * @param timeout ^CAEgԂ~bxŎw肷
	 * @return <ul><li>true -- R}h̑MIꍇ</li
	 *            ><li>false -- R}h̑MɎsꍇ</li
	 *            ></ul>
	 * @exception NotRunningFacilityAgentException
	 *                          FacilityAgent ~Ăꍇ
	 * @exception TimeoutException ^CAEgꍇ
	 * @exception InterruptedException ݂ꍇ
	 * @exception Exception 1)  FacilityAgent ݂Ȃ
	 *                      2)  FacilityAgent ̎擾Ɏs
	 *                      3)  FacilityAgentControlBlock ̃bN
	 *                         l/JɎs
	 *                      4)  FacilityAgentControlBlock 
	 *                         Ȃ
	 *                      5)  FacilityAgent ̉L[
	 *                         Ȃ
	 */
	public boolean responce(Object buf, long timeout)
						throws NotRunningFacilityAgentException
								, TimeoutException
								, InterruptedException
								, Exception {
		long start_millis = System.currentTimeMillis(), tto = timeout;
		boolean	r, rr, result = false;
		SharedObject	res_facbso = null;
		FacilityAgentControlBlock	res_facb = null;
		Message	resq = null;
		FacilityCommand	res = (FacilityCommand)buf;
		int	prev_status;

		// check the responce is needed?
		if (res.getResp_queue_name() == null) {
			return	true; // Responce is nothing.
		}

		// save the previouse status of this agent
		tto	= Utillity.check_timeout(start_millis, timeout);
		prev_status = get_status(tto);

		// change this agent status to WAIT
		tto	= Utillity.check_timeout(start_millis, timeout);
		set_status(FacilityAgentControlBlock.WAIT, tto);

		try {
			// check the destiny is a FacilityAgent or not?
			if (res.getResp_to_agent()) {
				// Destiny is a FacilityAgent

				// search the FACB of the destiny agent
				tto	= Utillity.check_timeout(start_millis, timeout);
				r = rr = false;
				res_facbso	=
						SharedObject.attach(res.getResp_queue_name());
				if (res_facbso == null) {
					throw new Exception("FacilityAgent.responce("
										+ buf + ", " + timeout + "): "
										+ res.getResp_queue_name()
										+ " isn't exist."
										);
				}

				// lock the destiny FACB (sharing, blocking timeout)
				tto	= Utillity.check_timeout(start_millis, tto);
				if ((r = res_facbso.take(true, true, tto)) == true) {
					// get the destiny agent
					try {
						res_facb = (FacilityAgentControlBlock)(
											res_facbso.get_object());
					} catch (Exception e) {
						// Failed to get the destiny agent!
						rr	= res_facbso.leave(); // unlock the destiny
						throw e;
					}

					// If the destiny FACB and agent are exist...
					if ((res_facb != null)
					&& res_facb.agent != null) {
						// get the responce-queue of the destiny
						resq	= res_facb.agent.resq;
					}

					rr	= res_facbso.leave(); // unlock the destiny FACB
				}
				if (!r || !rr) {
					// Failed to lock or unlock the destiny FACB!
					throw new Exception("FacilityAgent.responce("
										+ buf + ", " + timeout + "): "
										+ "res_facbso."
										+ ((!r)? "take": "leave")
										+ "() returns false."
										);
				}
				if (res_facb == null) {
					// The destiny FACB isn't exist!
					throw new Exception("FacilityAgent.responce("
										+ buf + ", " + timeout + "): "
										+ res.getResp_queue_name()
										+ " control-block isn't exist."
										);
				}
				if (res_facb.agent == null) {
					// The destiny agent isn't exist!
					throw new Exception("FacilityAgent.responce("
										+ buf + ", " + timeout + "): "
										+ "res_facb.agent is null."
										);
				}
				if (resq == null) {
					throw new Exception("FacilityAgent.responce("
										+ buf + ", " + timeout + "): "
										+ res.getResp_queue_name()
										+ " responce queue isn't exist."
										);
				}

				// Loop for timeout or interrupted...
				while (true) {
					int	facb_status = res_facb.NONE;

					// lock the destiny FACB (sharing, blocking timeout)
					r = rr = false;
					tto	= Utillity.check_timeout(start_millis, timeout);
					if ((r = res_facbso.take(true, true, tto))
															== true) {
						// get the destiny agent status
						facb_status	= res_facb.status;

						rr = res_facbso.leave(); // unlock the destiny
					}
					if (!r || !rr) {
						// Failed to lock or unlock the destiny FACB!
						throw new Exception("FacilityAgent.responce("
											+ buf + ", " + timeout
											+ "): res_facbso."
											+ ((!r)? "take": "leave")
											+ "() returns false."
											);
					}

					if (facb_status >= res_facb.TERM
					|| facb_status <= res_facb.INIT) {
						// The destiny agent status is illegal!
						throw new NotRunningFacilityAgentException(
									"FacilityAgent.responce("
									+ buf + ", " + timeout + "): \""
									+ res.getResp_queue_name() + "\" "
									+ "facility is not running status."
									);
					}

					// try to put the responce to the destiny queue
					tto	= Utillity.check_timeout(start_millis, timeout);
					try {
						// set the wait channel for Inspector
						wait_channel = resq;

						// wait for recieving the FacilityCommand...
						result = resq.put(res
										, false
										, true
										, ((tto < 100)? tto: 100)
										);
						break;
					} catch (TimeoutException e) {
						// If it reaches timeout, throw the exception
						if (tto < 100) throw e;
					}

					// check the interrupt-cause
					int interrupt_cause = get_interrupt_cause();
					if (interrupt_cause != res_facb.NOTHING) {
						// This agent was interrupted!
						throw new InterruptedException(
										"FacilityAgent.responce("
										+ buf + ", " + timeout + "): "
										+ "Interrupted "
										+ "(interrupt_cause = "
										+ interrupt_cause + ")"
										);
					}
				}
			}
			else {
				// search the responce-queue of the non-agent requester
				resq	= Message.attach(res.getResp_queue_name());
				if (resq == null) {
					// The requester's responce-queue isn't exist!
					throw new Exception("FacilityAgent.responce("
										+ buf + ", " + timeout + "): "
										+ "Message.attach("
										+ res.getResp_queue_name()
										+ ") returns null."
										);
				}

				// try to put the responce to the requester's queue
				tto	= Utillity.check_timeout(start_millis, timeout);
				result = resq.put(res, false, true, tto);
			}

			// if this puts the responce normally,
			// change the request command status to RESPONCED
			if (result) {
				res.setStatus(res.RESPONCED);
			}

			// restore this agent status
			tto	= Utillity.check_timeout(start_millis, timeout);
			set_status(prev_status, tto);
		} catch (Exception e) {
			// If the any exceptions are occured, restore agent status
			set_status(prev_status, 100);
			throw e;
		}

		return	result; // returns true: normal-end
						// returns false: error to put the responce
	}

	/**
	 * vR}h𑗐M܂B
	 *
	 * @param to_fac M<em>@\</em>
	 * @param buf vR}hBFaclityCommand ł邱
	 * @param timeout ^CAEgԂ~bŎw肷
	 * @exception InactiveFacilityException
	 *                               M<em>@\</em>񊈐̏ꍇ
	 * @exception TimeoutException ^CAEgꍇ
	 * @exception InterruptedException ݂ꍇ
	 * @exception Exception 1) M<em>@\</em>݂Ȃꍇ
	 *                      2) M<em>@\</em>̃bNl/J
	 *                         sꍇ
	 *                      3) M<em>@\</em>̗vL[
	 *                         Ȃꍇ
	 */
	public boolean put_request(String to_fac
							, Object buf
							, long timeout
							) throws InactiveFacilityException
									, TimeoutException
									, InterruptedException
									, Exception {
		long start_millis = System.currentTimeMillis(), tto = timeout;
		boolean	r, rr, result = false;
		Facility	req_fac = null;
		FacilityCommand	req = (FacilityCommand)buf;

		// check parameters
		if (to_fac == null
		|| to_fac.equals("")
		|| buf == null
		|| timeout < 0) {
			// The parameters are illegal!
			return	false;
		}

		// save the previouse status of this agent
		int prev_status = get_status(tto);

		// change this agent status to WAIT
		tto	= Utillity.check_timeout(start_millis, timeout);
		set_status(FacilityAgentControlBlock.WAIT, tto);

		try {
			// search the destiny facility
			tto	= Utillity.check_timeout(start_millis, timeout);
			req_fac	= Facility.attach(to_fac);
			if (req_fac == null) {
				// The destiny facility isn't exist!
				throw new Exception("FacilityAgent.put_request("
									+ to_fac + ", " + buf + ", "
									+ timeout + "): \""
									+ to_fac + "\" facility not exist."
									);
			}

			// loop for timeout or interrupted...
			while (true) {
				// try to put the request to the destiny facilty
				result	= false;
				tto	= Utillity.check_timeout(start_millis, timeout);
				try {
					// set the wait channel for Inspector
					wait_channel = req_fac;

					// wait for sending the FacilityCommand...
					result = req_fac.put_request(buf
											, ((tto > 100)? 100: tto)
											, false
											);

					break; // finish to send the request
				} catch (TimeoutException e) {
					// If it reaches timeout, throw the exception!
					if (tto <= 100) throw e;
				}

				// check the interrupt-cause of this agent
				int interrupt_cause	= get_interrupt_cause();
				if (interrupt_cause
							!= FacilityAgentControlBlock.NOTHING) {
					// This agent is interrupted!
					throw new InterruptedException("FacilityAgent."
											+ "put_request(" + to_fac
											+ ", " + buf + ", "
											+ timeout
											+ "): Interrupted "
											+ "(interrupt_cause = "
											+ interrupt_cause + ")"
											);
				}
			}

			// restore the previouse status of this agent
			tto	= Utillity.check_timeout(start_millis, timeout);
			set_status(prev_status, tto);
		} catch (Exception e) {
			// If any exception occures, restore the previouse status!
			set_status(prev_status, 100);
			throw e;
		}

		return	result; // returns true: normal-end
						// returns false: failed to put the request
	}

	/**
	 *  FacilityAgent ւ̉M܂B
	 *
	 * @param cmd ɑΉvR}h FacilityAgent
	 * @param timeout ^CAEgԂ~bxŎw肵܂ (msec)
	 * @exception FailedProcessingException
	 *                            vR}hMŏɎsꍇ
	 * @exception TimeoutException ^CAEgꍇ
	 * @exception InterruptedException ݂ꍇ
	 * @exception Exception cmd  null ̏ꍇ
	 */
	public FacilityCommand get_responce(Object cmd, long timeout)
								throws FailedProcessingException
									  , TimeoutException
									  , InterruptedException
									  , Exception {
		long start_millis = System.currentTimeMillis(), tto = timeout;
		FacilityCommand	req = (FacilityCommand)cmd, res = null;

		// Check the request command is legal?
		if (resq == null) {
			// The request command is illegal!
			throw new Exception("FacilityAgent.get_responce("
								+ cmd + ", " + timeout + "): "
								+ "resq is null."
								);
		}

		// save the previouse status of this agent
		int	prev_status = get_status(tto);

		// change the agent status to WAIT
		tto	= Utillity.check_timeout(start_millis, timeout);
		set_status(FacilityAgentControlBlock.WAIT, tto);

		try {
			// loop for timeout or interrupted...
			while (true) {
				// Check the request command status
				int	req_status = req.getStatus();
				if (req_status >= res.OCCURED_EXCEPTION) {
					// The request reciever failed processing!
					throw new FailedProcessingException(
									"FacilityAgent.get_responce("
									+ cmd + ", " + timeout + "): \""
									+ res.getProcessing_agent() + "\" "
									+ "agent failed processing ["
									+ "status = " + req_status + ", "
									+ "halt_cause = "
									+ res.getHalt_cause() + ", "
									+ "exception_class_name = "
									+ res.getException_class_name()
									+ "]"
									);
				}

				// try to get the responce
				tto	= Utillity.check_timeout(start_millis, timeout);
				try {
					// set the wait channel for Inspector
					wait_channel = resq;

					// wait for recieving the FacilityCommand...
					res	= (FacilityCommand)(resq.get(true, true
											, ((tto < 100)? tto: 100)
											));
					break; // finish to get the responce
				} catch (TimeoutException e) {
					// If it reaches the timeout, throw it!
					if (tto < 100)	throw e;
				}

				// check the interrupt-cause
				int interrupt_cause = get_interrupt_cause();
				if (interrupt_cause
							!= FacilityAgentControlBlock.NOTHING) {
					// This agent is interrupted!
					throw new InterruptedException(
									"FacilityAgent.get_responce("
									+ cmd + ", " + timeout + "): \""
									+ "Interrupted "
									+ "(interrupt_cause = "
									+ interrupt_cause + ")"
									);
				}
			}

			// restore the previouse status of this agent
			tto	= Utillity.check_timeout(start_millis, timeout);
			set_status(prev_status, tto);
		} catch (Exception e) {
			// If any exception occures, restore the previouse status!
			set_status(prev_status, 100);
			throw e;
		}

		return	res; // returns not-null: the recieved responce
					 // returns null: failed to get the responce
	}

	/**
	 * vR}h FacilityCommand 𑗐MẢM܂B
	 *
	 * @param to_fac vM<em></em>
	 * @param buf vR}h FacilityCommand
	 * @param timeout ^CAEgԂ~bxŎw肷 (msec)
	 * @exception Exception {@link #put_request} 
	 *                      {@link #get_responce} QƂ̂
	 */
	public FacilityCommand request(String to_fac
									, Object buf
									, long timeout
									) throws Exception {
		long start_millis = System.currentTimeMillis(), tto = timeout;
		FacilityCommand req = (FacilityCommand)buf;

		// set the facility-name, agent-ID, agent-name and
		// responce-to-agent-switch
		req.setFac_name(facname);
		req.setAid(aid);
		req.setResp_to_agent(true);
		req.setResp_queue_name(agname);

		// send the request-command
		tto	= Utillity.check_timeout(start_millis, timeout);
		if (put_request(to_fac, req, tto)) {
			// recieve the responce
			tto	= Utillity.check_timeout(start_millis, timeout);
			req	= get_responce(buf, tto);
		}

		return	req; // returns not-null: the responce
					 // returns null: failed to transmit
	}

	// get the concurrency degree
	// @exception Exception 1) the current concurrency is illegal
	//                      2) fail to lock or unlock the facility
	private int get_now_concurrency() throws Exception {
		boolean	r, rr;
		Facility	fac = null;
		int	result	= -1;

		// search the facility
		fac	= Facility.attach(facname);

		// lock the facility (sharing, block infinite)
		r = rr = false;
		if ((fac != null)
		&& (r = fac.take(true, true, 0)) == true) {
			if ((fac.max_concurrency < fac.concurrency)
			|| fac.concurrency < 0) {
				// The current concurrency is illegal!
				throw new Exception("FacilityAgent.get_now_concurrency"
								+ "(): fac.max_concurrency "
								+ fac.max_concurrency + " and "
								+ "fac.concurrency "
								+ fac.concurrency + " are illegal."
								);
			}

			result	= fac.concurrency; // get the current concurrency
		
			rr = fac.leave(); // unlock the facility
		}
		if (!r || !rr) {
			// Failed to lock or unlock the facility
			throw new Exception("FacilityAgent.get_now_concurrency(): "
								+ "fac." + ((!r)? "take": "leave")
								+ "() returns false."
								);
		}

		return	result; // returns the current concurrency
	}

	// clear the interrupt-cause
	// @param interrupt_cause clearing interrupt-cause bit
	// @exception Exception 1) the FACB is null
	//                      2) failed to lock or unlock the FACB
	private void clear_interrupt_cause(int interrupt_cause)
												throws Exception {
		boolean	r, rr;
		SharedObject	facbso = null;
		FacilityAgentControlBlock	facb	= null;

		// search the FACB of this agent
		facbso	= SharedObject.attach(agname);

		// lock the FACB (monopolize, blocking infinite)
		r = rr = false;
		if ((facbso != null)
		&& (r = facbso.take(false, true, 0)) == true) {
			try {
				// get the FACB
				facb = (FacilityAgentControlBlock)(facbso.get_object());
			} catch (Exception e) {
				// Failed to get the FACB!
				rr	= facbso.leave();
				throw e;
			}
			if (facb == null) {
				// The FACB is null!
				rr	= facbso.leave(); // unlock the FACB
				throw new Exception("FacilityAgent."
									+ "clear_interrupt_cause("
									+ interrupt_cause + "): "
									+ "facb is null."
									);
			}

			// clear the interrupt-cause (specified bit turns off)
			facb.interrupt_cause	&= ~interrupt_cause;

			rr = facbso.leave(); // unlock the FACB
		}
		if (!r || !rr) {
			// Failed to lock or unlock the FACB!
			throw new Exception("FacilityAgent.clear_interrupt_cause("
								+ interrupt_cause + "):"
								+ " facbso." + ((!r)? "take": "leave")
								+ "() returns false."
								);
		}
	}

	// make the formatted string of the exception
	// @param e the exception
	private String make_exception_info(Exception e) {
		StringBuffer	sb = new StringBuffer(4096);

		// set the exception message and the stack traces
		sb.append("{\"");
		Utillity.format_exception_info(sb, e);
		sb.append("}");

		return	sb.toString(); // returns the formatted string
	}

	/**
	 * <em>@\</em>̃OEbZ[Wo͂܂B
	 * ÕtH[}bg 
	 * yyyy/mm/dd HH:MM:SS.sss:<em>log_class</em
	 * >:<em>@\</em>G[WFg<status>:<em>errcode</em
	 * >:<em>msg</em>
	 *ƂȂ܂B
	 *
	 * @param log_class OExw肵܂BLog NXQƂ̂
	 * @param errcode G[ER[hw肵܂
	 * @param msg G[EbZ[Ww肵܂
	 */
	protected void log(int log_class, int errcode, String msg) {
		boolean	r = false, rr = false;
		Facility	fac = Facility.attach(facname);
		int	status	= FacilityAgentControlBlock.NONE;

		if (fac != null) {
			try {
				String delimit	= fac.get_log_delimit();

				FacilityAgentControlBlock facb = null;

				// search the agent
				SharedObject	facbso = SharedObject.attach(agname);

				// lock the FACB (sharing, blocking infinite)
				r = rr = false;
				if ((facbso != null)
				&& (r = facbso.take(true, true, 0)) == true) {
					try {
						// get the FACB
						facb = (FacilityAgentControlBlock)(
												facbso.get_object());
					} catch (Exception e) {
						// Failed to get the FACB!
						rr	= facbso.leave();
						return; // NEVER THROW EXCEPTION
					}

					// get the FACB status
					if (facb != null) {
						status	= facb.status;
					}

					rr	= facbso.leave(); // unlock the FACB
				}

				// check the FACB status is legal?
				if (((((facbso != null)
				&& r == true)
				&& rr == true)
				&& status != facb.NONE)
				&& delimit != null) {
					// format log-message
					//	Format:
					//		date-time:log_class:agname<status>:errcode:msg
					StringBuffer sb = new StringBuffer(4096);
					sb.append(agname);
					sb.append("<").append(status).append(">");
					sb.append(delimit).append(errcode);
					sb.append(delimit).append(msg);

					fac.log(log_class, sb.toString()); // logging to Log
				}
			} catch (Exception e) {
				; // NEVER THROW EXCEPTION
			}
		}
	}

	// set the halt-cause and the interrupt-cause
	// @param halt_cause the cause of halting
	// @param e the occured exception
	private void set_halt_situation(int halt_cause, Exception e) {
		this.halt_cause[fatal_exception_cnt]	= halt_cause;
		fatal_exception[fatal_exception_cnt]	= e;
	}

	// get the halt-cause
	private int get_halt_cause() {
		return halt_cause[fatal_exception_cnt];
	}

	// check this FacilityAgent implements the TimerUser interface
	// @exception Exception this agent isn't a TimerUser
	private void check_this_is_TimerUser() throws Exception {
		if (!(this instanceof TimerUser)) {
			throw new Exception(
						"FacilityAgent.check_this_is_TimerUser(): "
						+ "this \"" + agname
						+ "\" agent isn't a TimerUser, "
						+ "but this recieved a TimerComand."
						);
		}
	}

	// get the Timer that application runs
	// @return <ul><li>null -- this application doesn't run
	//                        the Timer.</li
	//            ><li>not-null -- the Timer</li
	//            ></ul>
	// @exception Exception 1) failed to locl/unlock the facility
	private Timer get_app_timer() throws Exception {
		// search the facility that runs this agent
		Facility fac = Facility.attach(facname);
		if (fac == null) {
			// The facility is null!
			return	null; // Failed to get the Timer!
		}

		// get the timer
		Timer timer = null;
		// lock the facility (sharing, blocking infinite)
		boolean r = false, rr = false;
		if ((r = fac.take(true, true, 0)) == true) {
			timer	= fac.get_app_timer();

			rr = fac.leave(); // unlock the facility
		}
		if (!r || !rr) {
			// Occures exception to get the application!
			throw new Exception("FacilityAgent.get_app_timer(): "
								+ "fac." + ((!r)? "take": "leave")
								+ "() returns false."
								);
		}

		return	timer; // returns the timer or null
	}
					
	/**
	 * TimerUser C^tF[X FacilityAgent pA
	 * ^C}Jn܂B
	 *
	 * @param tc ^C}@\ɓo^^CAEgݒ
	 * @return <ul><li>true -- ^C}Jnɐꍇ</li
	 *            ><li>false -- ^C}JnɎsꍇ</li
	 *            ></ul>
	 * @exception Exception -- TimerUser ĂȂ
	 *                         <em>G[WFg</em>Ăяoꍇ
	 */
	protected boolean timer_start(TimerCommand tc) throws Exception {
		// check this agent implements TimerUser?
		check_this_is_TimerUser(); // if not, Throws Exception!

		long intervals = 0;

		// check the timer command is set completely?
		if (((tc == null)
		|| (intervals = tc.getIntervals()) <= 0)
		|| tc.getHalt_this_timer()) {
			// This timer command is illegal!
			return false; // Failed to start the timer
		}

		// get the Timer that application runs
		Timer	timer = get_app_timer();
		if (timer == null) {
			// This application has no Timer!
			return	false; // Failed to start the timer
		}

		// set the FacilityCommand fields
		tc.setAid(aid);
		tc.setFac_name(facname);
		tc.setResp_queue_name(facname);
		tc.setResp_to_agent(false);
		tc.setStatus(tc.INIT);

		return (timer.add(intervals, tc.getPeriodic(), tc) != null);
	}

	/**
	 * TimerUser C^tF[X FacilityAgent Jn
	 * ^C}܂B
	 *
	 * @param tc ^C}@\ɓo^^CAEgݒ
	 * @return <ul><li>true -- ^C}ɐꍇ</li
	 *            ><li>false -- ^C}Ɏsꍇ</li
	 *            ></ul>
	 * @exception Exception -- TimerUser ĂȂ
	 *                         <em>G[WFg</em>Ăяoꍇ
	 */
	protected boolean timer_cancel(TimerCommand tc) throws Exception {
		// check this agent implements TimerUser?
		check_this_is_TimerUser(); // if not, Throws Exception!

		// check the timer command is set completely?
		if ((tc == null)
		|| tc.getIntervals() <= 0) {
			// This timer command is illegal!
			return false; // Failed to start the timer
		}
		if (tc.getHalt_this_timer()) {
			// The application timer had halt!
			return	 true; // already, this timer is canceled by app
		}

		// get the Timer that application runs
		Timer	timer = get_app_timer();
		if (timer == null) {
			// This application has no Timer!
			return	false; // Failed to start the timer
		}

		return (timer.cancel(tc) != null);
	}

	// process the TimerCommand
	private int process_timer_command(FacilityCommand cmd)
												throws Exception {
		check_this_is_TimerUser();

		return	(((TimerCommand)cmd).getHalt_this_timer())?
					((TimerUser)this).timer_halt((TimerCommand)cmd):
					((TimerUser)this).timer_expired((TimerCommand)cmd);
	}

	/** FacilityAgent ̃C[v */
	public void run() { // Runnable needs to implement this method.
		int	last_status = FacilityAgentControlBlock.NONE;

		// initialize the halt-cause and the interrupt-cause
		fatal_exception_cnt	= 0;
		set_halt_situation(NORMALEND, null);

		// INIT-phase to initialize this agent
		try {
			// check this agent status. it must be INIT
			last_status = get_status(0);
			if (last_status != FacilityAgentControlBlock.INIT) {
				// This agent status isn't INIT!
				// set the halt-cause and the interrupt-cause
				set_halt_situation(ILLEGAL_STATUS, null);

				// log the FATAL message
				log(Log.FATAL, get_halt_cause()
					, "Illeagl FacilityAgent-status (" + last_status
					+ ") in FacilityAgent.run( initialize ). "
					+ "Halt this agent."
					);

				// set this agent status ZOMB
				try {
					set_status(FacilityAgentControlBlock.ZOMB, 0);
				} catch (Exception e) {
					// set the 2nd halt-cause and
					// the 2ndinterrupt-cause
					set_halt_situation(get_halt_cause(), e);
				}
				return; // Failed!
			}

			// do init() to initialize this agent
			if (init() == false) {
				// init() returns error-code!
				// set the halt-cause and the interrupt-cause
				set_halt_situation(INIT_RETURNED_FALSE, null);

				// log the FATAL message
				log(Log.FATAL, get_halt_cause()
					, "Failed in init(). Halt this agent."
					);

				// set this agent status ZOMB
				try {
					set_status(FacilityAgentControlBlock.ZOMB, 0);
				} catch (Exception e) {
					// set the 2nd halt-cause and
					// the 2ndinterrupt-cause
					set_halt_situation(get_halt_cause(), e);
				}
				return; // Failed!
			}
		} catch (Exception e) {
			// check the occured exception isn't InterruptedException?
			if (!(e instanceof InterruptedException)) {
				// Occured exception in INIT-phase!
				// set the halt-cause and the interrupt-cause
				set_halt_situation(EXCEPTION_IN_INIT_PHASE, e);

				// log the FATAL message
				log(Log.FATAL, get_halt_cause()
					, "Occured Exception in init(). "
					+ make_exception_info(e)
					+ " Can't start this agent."
					);

				// set this agent status ZOMB
				try {
					set_status(FacilityAgentControlBlock.ZOMB, 0);
				} catch (Exception ee) { ; }
				return; // Failed!
			}
		} // INIT-phase

		// check the halt-cause is NORMALEND?
		if (get_halt_cause() == NORMALEND) {
			// The main-loop of this agent...
			while (true) {
				// get the current concurrency and the interrupt-cause
				int now_concurrency = 0;
				int	interrupt_cause = FacilityAgentControlBlock.NONE;
				try {
					now_concurrency	= get_now_concurrency();
				} catch (Exception e) {
					// check the exception isn't InterruptedException?
					if (!(e instanceof InterruptedException)) {
						// Failed to get the current concurrency!
						// set the halt-cause and the interrupt-cause
						set_halt_situation(
									  EXCEPTION_IN_GET_NOW_CONCURRENCY
									, e
									);

						// log the FATAL message
						log(Log.FATAL, get_halt_cause()
							, "Occured Exception in "
							+ "get_now_concurrency(). "
							+ make_exception_info(e)
							+ " Halt this agent."
							);

						break; // to do terminate()!
					}
				}
				try {
					interrupt_cause = get_interrupt_cause();
				} catch (Exception e) {
					// set the halt-cause and the interrupt-cause
					set_halt_situation(EXCEPTION_IN_GET_INTERRUPT_CAUSE
										, e
										);

					// log the FATAL message
					log(Log.FATAL, get_halt_cause()
						, "Occured Exception in get_interrupt_cause(). "
						+ make_exception_info(e)
						+ " Halt this agent."
						);

					break; // to do terminate()!
				} // get the current concurrency and the interrupt-cause

				// check this agent gone SUSPEND-status?
				if ((now_concurrency <= aid)
				|| (interrupt_cause
						& FacilityAgentControlBlock.SUSPEND) != 0) {
					try {
						// set this agent status to SUSP
						set_status(FacilityAgentControlBlock.SUSP, 0);

						// clear the SUSPEND-bit of the interrupt-cause
						clear_interrupt_cause(
									FacilityAgentControlBlock.SUSPEND
									);

						// do suspend() to notify suspending
						if (suspend() == false) {
							// suspend() returns error-code!
							// set the halt-cause and
							// the interrupt-cause
							set_halt_situation(SUSPEND_RETURNS_FALSE
												, null
												);

							// log the FATAL message
							log(Log.FATAL, get_halt_cause()
								, "Failed in suspend(). "
								+ "Halt this agent."
								);

							break; // to do terminate()!
						}

						// loop to wait for the interrupt...
						do {
							synchronized (this) {
								wait(100); // wait slight times...
							}
							// get the interrupt-cause
							interrupt_cause = get_interrupt_cause();
						} while ((interrupt_cause
								& ~FacilityAgentControlBlock.SUSPEND)
																== 0);
					} catch (Exception e) {
						// check the exception isn't
						// InterruptedException
						if (!(e instanceof InterruptedException)) {
							// set the halt-cause and
							// the interrupt-cause
							set_halt_situation(EXCEPTION_IN_SUSPEND, e);

							// log the FATAL message
							log(Log.FATAL, get_halt_cause()
								, "Occured Exception in suspend(). "
								+ make_exception_info(e)
								+ " Halt this agent."
								);

							break; // to do terminate()!
						}
					}
					continue; // Polling the current interrupt-causes
				} // SUSPEND-status

				// check this agent gone the RESUME-phase?
				if ((interrupt_cause
						& FacilityAgentControlBlock.RESUME) != 0) {
					try {
						// set this agnet status to RESU
						set_status(FacilityAgentControlBlock.RESU, 0);


						// clear the RESUME-bit of the interrupt-cause
						clear_interrupt_cause(
									FacilityAgentControlBlock.RESUME
									);

						// do resume() to notify resuming
						if (resume() == false) {
							// resume() returns error-code!
							// set the halt-cause and
							// the interrupt-cause
							set_halt_situation(RESUME_RETURNS_FALSE
												, null
												);

							// log the FATAL message
							log(Log.FATAL, get_halt_cause()
								, "Failed in resume(). Halt this agent."
								);

							break; // to do terminate()!
						}
					} catch (Exception e) {
						// check the exception isn't
						// InterruptedException?
						if (!(e instanceof InterruptedException)) {
							// set the halt-cause and
							// the interrupt-cause
							set_halt_situation(EXCEPTION_IN_RESUME, e);

							// log the FATAL message
							log(Log.FATAL, get_halt_cause()
								, "Occured Exception in resume(). "
								+ make_exception_info(e)
								+ " Halt this agent."
								);

							break; // to do terminate()!
						}
					}
					continue; // Polling the current interrupt-causes
				} // RESUME-phase

				// check this agent gone the TERMINATE-status?
				if ((interrupt_cause
						& FacilityAgentControlBlock.TERMINATE) != 0) {
					break; // to do terminate()!
				}

				// WAIT-phase to recieve the request
				try {
					// set this agent status to WAIT
					set_status(FacilityAgentControlBlock.WAIT, 0);

					// try to recieve the request-command
					if ((last_command = get_request(100)) == null) {
						// The reuest-queue is destroyed!
						// set the halt-cause and the interrupt-cause
						set_halt_situation(GET_REQUEST_RETURNED_NULL
											, null
											);

						// log the FATAL message
						log(Log.FATAL, get_halt_cause()
							, "Failed in get_request(). "
							+ "Halt this agent."
							);

						break; // to do terminate()!
					}
				} catch (Exception e) {
					// check the exception isn't InterruptedException
					// nor TimeoutException?
					if (!(e instanceof InterruptedException)
					&& !(e instanceof TimeoutException)) {
						// set the halt-cause and the interrupt-cause
						set_halt_situation(EXCEPTION_IN_GET_REQUEST, e);

						// log the FATAL message
						log(Log.FATAL, get_halt_cause()
							, "Occured Exception in get_request(). "
							+ make_exception_info(e)
							+ " Halt this agent."
							);

						break; // to do terminate()!
					}
					continue; // Polling the current interrupt-causes
				} // WAIT-phase
					
				// PROC-phase to process the recieved request-command
				try {
					int	retcode_process = NORMALEND;

					// set this agent status to PROC
					set_status(FacilityAgentControlBlock.PROC, 0);

					// do process() to process the request-command
					try {
						if (last_command instanceof TimerCommand) {
							retcode_process = process_timer_command(
														last_command
														);
						}
						else {
							retcode_process = process(last_command); 
						}
					} catch (Exception e) {
						// check the request-command isn't responded?
						if (last_command.getStatus()
										!= last_command.RESPONCED) {
							// set the request-command status
							// to OCCURED-EXCEPTION, and set
							// the class-name of the exception
							last_command.setStatus(
										last_command.OCCURED_EXCEPTION);
							last_command.setException_class_name(
										e.getClass().getName()
										);
						}

						// check the exception is TimeoutException?
						// or isn't it InterruptedException?
						if (e instanceof TimeoutException) {
							// set the halt-cause and
							// the interrupt-cause
							set_halt_situation(TIMEOUTED_IN_PROCESS, e);

							// log the WARN-ing message
							log(Log.WARN, get_halt_cause()
								, "Occured Timeout in process()."
								+ make_exception_info(e)
								+ " This agent continues..."
								);
						}
						else if (!(e instanceof InterruptedException)) {
							// set the halt-cause and
							// the interrupt-cause
							set_halt_situation(EXCEPTION_IN_PROCESS, e);

							// log the FATAL message
							log(Log.FATAL, get_halt_cause()
								, "Occured Exception in process(). "
								+ make_exception_info(e)
								+ " halt this agent."
								);

							break; // to do terminate()!
						}
					}

					// check the return-code of process() is illegal?
					if (retcode_process != NORMALEND) {
						// set the halt-cause and the interrupt-cause
						set_halt_situation(retcode_process, null);

						// check the request-command isn't responded?
						if (last_command.getStatus()
										!= last_command.RESPONCED) {
							// set the return-code of process()
							// to halt_cause
							last_command.setStatus(
										last_command.ABNORMAL_ENDED);
							last_command.setHalt_cause(retcode_process);
						}

						// log the FATAL message
						log(Log.FATAL, get_halt_cause()
							, "process() returns error. "
							+ "Halt this agent."
							);

						break; // to do terminate()!
					}
				} catch (Exception e) {
					// check the exception isn't TimeoutException
					// nor InterruptedException?
					if (!(e instanceof TimeoutException)
					&& !(e instanceof InterruptedException)) {
						// set the halt-cause and the interrupt-cause
						set_halt_situation(EXCEPTION_IN_PROCESS, e);

						// log the FATAL message
						log(Log.FATAL, get_halt_cause()
							, "Occured Exception in process(). "
							+ make_exception_info(e)
							+ " Halt this agent."
							);

						break; // to do terminate()!
					}
				} // PROC-phase
			} // end of the main-loop of this agent
		}

		// TERM-phase to terminate this agent
		++fatal_exception_cnt;
		try {
			// set this agent status to TERM
			set_status(FacilityAgentControlBlock.TERM, 0);

			// clear the TERMINATE-bit of the interrupt-cause
			clear_interrupt_cause(FacilityAgentControlBlock.TERMINATE);

			// do terminate() to notify terminated
			if (terminate() == false) {
				// terminate() returns error-code!
				// set the halt-cause and the interrupt-cause
				set_halt_situation(TERMINATE_RETURNED_FALSE, null);

				// log the FATAL message
				log(Log.FATAL, get_halt_cause()
					, "Failed in terminate(). Halt this agent."
					);

			}
		} catch (Exception e) {
			// set the halt-cause and the interrupt-cause
			set_halt_situation(EXCEPTION_IN_TERMINATE, e);

			// log the FATAL message
			log(Log.FATAL, get_halt_cause()
				, "Occured Exception in terminate(). "
				+ make_exception_info(e)
				+ " Halt this agent."
				);
		} // TERM-phase

		// ZOMB-phase
		try {
			// set this agent status to ZOMB
			set_status(FacilityAgentControlBlock.ZOMB, 0);
		} catch (Exception e) {
			// set the halt-cause and the interrupt-cause
			set_halt_situation(EXCEPTION_IN_ZOMBINATE, e);

			// log the FATAL message
			log(Log.FATAL, get_halt_cause()
				, "Occured Exception in set_status(ZOMB). "
				+ make_exception_info(e)
				+ " Halt this agent."
				);
		} // ZOMB-phase
	}
}
