/***********************************************************************
 * File: FacilityAgentControlBlock.java
 * 	(Extracted from
 *	   "$Id: FacilityAgentControlBlock.java,v 1.3 2004/06/12 17:38:37 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a FacilityAgentControlBlock
 * abstract utility class.
 *  The instances of this class is shared from Facility and
 * FacilityAgent instances.  The instance stores the status, processing
 * phases and the thread/agent handle for running FacilityAgent.
 *  (Refered Class: Facility, FacilityAgent and SharedObject
 *  (Refered Interface: Sharable)
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package	my_util;

/**
 * <p>Facility ɂ芈ԂȂǂǗ FacilityAgent
 *    CX^X̏Xe[^XA݌ƊǗ (
 *    Facility ́AFacilityAgent ́EIDAL[) Ȃǂ
 *    ێ鋤LIuWFNgłB</p>
 *
 * @author maoyam
 * @version 1.0
 * @see Facility
 * @see FacilityAgent
 * @see Sharable
 */
public class FacilityAgentControlBlock implements Sharable {
	/**  FacilityAgent ǗubN Facility */
	protected Facility fac = null;
	/** ̊ǗubNɊ֘Atꂽ FacilityAgent ̖ */
	protected String agname = null;
	/** ̊ǗubNɊ֘Atꂽ FacilityAgent  ID */
	protected int agid = -1;
	/** ̊ǗubNɊ֘Atꂽ FacilityAgent ̉L[ */
	protected int resq_len	= 0;

	/** ݌: ݂ĂȂƂ */
	static final protected int NOTHING	 = 0x0;
	/** ݌: fv銄݂Ƃ */
	static final protected int SUSPEND	 = 0x1;
	/** ݌: Av銄݂Ƃ */
	static final protected int RESUME	 = 0x2;
	/** ݌: ~v銄݂Ƃ */
	static final protected int TERMINATE = 0x4;
	/** ݌rbgE}XNƂĕێ */
	protected int interrupt_cause = NOTHING;

	/**
	 * <em>G[WFg</em>̏:
	 *     ̃XbhƊ֘AtĂȂ
	 */
	static final protected int NONE = 0;
	/**
	 * <em>G[WFg</em>̏:
	 *     ̃XbhƊ֘Atꂽ
	 */
	static final protected int IDLE = 1;
	/** <em>G[WFg</em>̏: sĂ */
	static final protected int INIT = 2;
	/** <em>G[WFg</em>̏: fsĂ */
	static final protected int SUSP = 3;
	/**
	 * <em>G[WFg</em>̏:
	 *     fԂ̕AsĂ
	 */
	static final protected int RESU = 4;
	/** <em>G[WFg</em>̏: L[o͏sĂ */
	static final protected int WAIT = 5;
	/**
	 * <em>G[WFg</em>̏:
	 *     vR}h̏sĂ
	 */
	static final protected int PROC = 6;
	/** <em>G[WFg</em>̏: ~sĂ */
	static final protected int TERM = 7;
	/** <em>G[WFg</em>̏: ~(]r) */
	static final protected int ZOMB = 8;
	/** <em>G[WFg</em>̏Ԃێ */
	protected int status = NONE;

	/** <em>G[WFg</em>sĂXbh */
	protected Thread thr = null;
	/** <em>G[WFg</em> FacilityAgent */
	protected FacilityAgent	agent = null;

	/** Sharable C^tF[X̎K{ȃ\bhBƂĂ */
	public boolean initialize(String[] vals) { return true; }
}
