/***********************************************************************
 * File: FacilityConf.java
 * 	(Extracted from
 *	   "$Id: FacilityConf.java,v 1.3 2004/07/04 12:23:27 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a FacilityConf utility class.
 *  This instance describes the configuration of the Facility.
 *  (Refer Class: Application, Facility, FacilityAgent)
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package my_util;

import my_util.Log;

/**
 * <p><em>@\</em>̍\`邽߂̃NXłB</p>
 * <p><em>AvP[V</em>L<em>@\</em>ɐA
 * Application NX̃RXgN^ɓn܂B</p>
 *
 * @author maoyam
 * @version 1.0
 * @see Application
 * @see Facility
 * @see FacilityAgent
 */
public class FacilityConf {

	/** RXgN^B<em>@\</em>̍\w肵܂B
	 *
	 * @param name <em>@\</em>
	 * @param agclass_name <em>G[WFg</em>̃NX
	 * @param max_concurrency <em>@\</em>̍ő啽sx
	 * @param concurrency <em>@\</em>̕sx̏l
	 * @param log_date_format_pattern
	 *       <em>@\</em>̃OtEtH[}bgEp^[B
	 *       java.text.SimpleDateFormat QƂ̂ƁB
	 * @param log_path <em>@\</em>̃Oo͐EpX
	 * @param log_encoding Oo͐̕GR[fBO
	 * @param log_delimit OEtB[h؂蕶
	 * @param log_level OExBLog QƂ̂
	 * @param resq_len <em>@\</em>̉L[̃L[
	 */
	public FacilityConf(String name
						, String agclass_name
						, int max_concurrency
						, int concurrency
						, String log_date_format_pattern
						, String log_path
						, String log_encoding
						, String log_delimit
						, int log_level
						, int resq_len
						) {
		this.name = name;
		this.agclass_name = agclass_name;
		this.max_concurrency = max_concurrency;
		this.concurrency = concurrency;
		this.log_df_pattern = log_date_format_pattern;
		this.log_path = log_path;
		this.log_encoding = log_encoding;
		this.log_delimit = log_delimit;
		this.log_level = log_level;
		this.resq_len = resq_len;
	}

	// name of the facility
	private String name = null;
	/**
	 * <em>@\</em>̂ݒ肵܂
	 *
	 * @param name <em>@\</em>
	 */
	public void setName(String name) {
		synchronized(this) { this.name = name; }
	}
	/**
	 * <em>@\</em>̂擾܂
	 * 
	 * @return <em>@\</em>
	 */
	public String getName() { synchronized (this) { return name; } }

	// name of the agent class
	private String agclass_name = null;
	/**
	 * <em>G[WFg</em>̃NXݒ肵܂
	 *
	 * @param agclass_name <em>G[WFg</em>̃NX
	 */
	public void setAgclass_name(String agclass_name) {
		synchronized (this) { this.agclass_name = agclass_name; }
	}
	/**
	 * <em>G[WFg</em>̃NX擾܂
	 *
	 * @return <em>G[WFg</em>̃NX
	 */
	public String getAgclass_name() {
		synchronized (this) { return agclass_name; }
	}

	// maximun concurrency of the facility
	private int max_concurrency = 0;
	/**
	 * <em>@\</em>̍ősxݒ肵܂
	 *
	 * @param max_concurrency <em>@\</em>̍ősx
	 */
	public void setMax_concurrency(int max_concurrency) {
		synchronized (this) { this.max_concurrency = max_concurrency; }
	}
	/**
	 * <em>@\</em>̍ősx擾܂
	 *
	 * @return <em>@\</em>̍ősx
	 */
	public int getMax_concurrency() {
		synchronized (this) { return max_concurrency; }
	}

	// the current concurrency of the facility
	private int concurrency = 0;
	/**
	 * <em>@\</em>̕sx̏lݒ肵܂
	 *
	 * @param concurrency <em>@\</em>̕sx̏l
	 */
	public void setConcurrency(int concurrency) {
		synchronized (this) { this.concurrency = concurrency; }
	}
	/**
	 * <em>@\</em>̕sx̏l擾܂
	 *
	 * @return <em>@\</em>̕sx̏l
	 */
	public int getConcurrency() {
		synchronized (this) { return concurrency; }
	}

	// date-time formatting pattern for logging
	private String log_df_pattern = null;
	/**
	 * <em>@\</em>̃OtEtH[}bgEp^[ݒ
	 * ܂
	 *
	 * @param log_date_format_pattern
	 *       <em>@\</em>̃OtEtH[}bgEp^[B
	 *       java.text.SimpleDateFormat QƂ̂ƁB
	 */
	public void setLog_df_pattern(String log_date_format_pattern) {
		synchronized (this) {
			this.log_df_pattern = log_df_pattern;
		}
	}
	/**
	 * <em>@\</em>̃OtEtH[}bgEp^[擾
	 * ܂
	 *
	 * @return <em>@\</em>̃OtEtH[}bgEp^[
	 */
	public String getLog_df_pattern() {
		synchronized (this) { return log_df_pattern; }
	}

	// path of the facility logs
	private String log_path = null;
	/**
	 * <em>@\</em>̃Oo͐pXݒ肵܂
	 *
	 * @param log_path <em>@\</em>̃Oo͐pX
	 */
	public void setLog_path(String log_path) {
		synchronized (this) { this.log_path = log_path; }
	}
	/**
	 * <em>@\</em>̃Oo͐pX擾܂
	 *
	 * @return <em>@\</em>̃Oo͐pX
	 */
	public String getLog_path() {
		synchronized (this) { return log_path; }
	}

	// encoding of the facility logs
	private String log_encoding = null;
	/**
	 * <en>@\</em>O̕GR[fBOݒ肵܂
	 *
	 * @param log_encoding <en>@\</em>O̕GR[fBO
	 */
	public void setLog_encoding(String log_encoding) {
		synchronized (this) { this.log_encoding = log_encoding; }
	}
	/**
	 * <en>@\</em>O̕GR[fBO擾܂
	 *
	 * @return <en>@\</em>O̕GR[fBO
	 */
	public String getLog_encoding() {
		synchronized (this) { return log_encoding; }
	}

	// delimitter of the facility log fields
	private String log_delimit = null;
	/**
	 * <em>@\</em>ÕtB[h؂蕶ݒ肵܂
	 *
	 * @param log_delimit <em>@\</em>ÕtB[h؂蕶
	 */
	public void setLog_delimit(String log_delimit) {
		synchronized (this) { this.log_delimit = log_delimit; }
	}
	/**
	 * <em>@\</em>ÕtB[h؂蕶擾܂
	 *
	 * @return <em>@\</em>ÕtB[h؂蕶
	 */
	public String getLog_delimit() {
		synchronized (this) { return log_delimit; }
	}

	// level of the facility logs
	private int log_level = 0;
	/**
	 * <em>@\</em>Oɏo͂̃xݒ肵܂
	 *
	 * @param log_level <em>@\</em>Oɏo͂̃x
	 */
	public void setLog_level(int log_level) {
		synchronized (this) { this.log_level = log_level; }
	}
	/**
	 * <em>@\</em>Oɏo͂̃x擾܂
	 *
	 * @return <em>@\</em>Oɏo͂̃x
	 */
	public int getLog_level() {
		synchronized (this) { return log_level; }
	}

	// length of the facility responce queue
	private int resq_len = 0;
	/**
	 * <em>@\</em>̉L[̃L[ݒ肵܂
	 *
	 * @param resq_len <em>@\</em>̉L[̃L[
	 */
	public void setResq_len(int resq_len) {
		synchronized (this) { this.resq_len = resq_len; }
	}
	/**
	 * <em>@\</em>̉L[̃L[擾܂
	 *
	 * @return <em>@\</em>̉L[̃L[
	 */
	public int getResq_len() {
		synchronized (this) { return resq_len; }
	}
}
