/***********************************************************************
 * File: InspectionData.java
 * 	(Extracted from
 *	   "$Id: InspectionData.java,v 1.2 2004/06/28 14:51:00 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a InspectionData utility class.
 *  (Refered Class: Inspector, Apllication)
 *  (Refered Interface: Inspectable)
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package my_util;

/**
 * <p><em>CXyN^</em>ɊĎNXA̓Ԃo͂
 * f[^EReiłB</p>
 * o͂f[^́AԂ̖Oƒl̑΂Ƃĕ\܂B
 *
 * @author maoyam
 * @version 1.0
 * @see Inspector
 * @see Inspectable
 * @see Application
 */
public class InspectionData {

	/**
	 * Ԃ킷 (OEl) ΂`Ă܂B
	 *
	 * @author maoyam
	 * @version 1.0
	 * @see InspectionData
	 * @see Inspector
	 * @see Inspectable
	 * @see Apllication
	 */
	static class Datum {

		/** ̖O */
		protected String name = null;
		/** ̒l () */
		protected String value = null;
		/** ̒l (InspectionData) */
		protected InspectionData values = null;

		/**
		 * RXgN^: (OEl) ΂𐶐܂B
		 *
		 * @param name f[^
		 * @param value f[^l
		 */
		protected Datum(String name, String value) {
			this.name	= name;
			this.value	= value;
			this.values	= null;
		}

		/**
		 * RXgN^: (OEInspectionData) ΂𐶐܂B
		 *
		 * @param name f[^
		 * @param values InspectionData ŕ\ꂽ̒l
		 */
		protected Datum(String name, InspectionData values) {
			this.name	= name;
			this.value	= null;
			this.values	= values;
		}
	}

	/** [߂ (OEl) ΂̔z */
	protected Datum[]	entries = null;

	// append a new element to entries array
	private void extend_entries() {
		// check the entries array isn't exist?
		if (entries == null) {
			// construct the entries array
			entries	= new Datum[1];
		}
		else {
			// extend the entries array
			Datum[] es = new Datum[entries.length + 1];
			int i;
			for (i = 0; i < entries.length; ++i) {
				es[i]	= entries[i];
			}
			es[i]	= null;
			entries	= es;
		}
	}

	/**
	 *  (OEl) ΂ {@link #entries} ɒǉ܂B
	 *
	 * @param name f[^
	 * @param value f[^l
	 */
	protected void add(String name, String value) {
		// append a new element to entries array
		extend_entries();

		// set this (name . value) dot-pair to the tail of entries array
		entries[entries.length - 1]	= new Datum(name, value);
	}

	/**
	 *  (OEInspectionData) ΂ {@link #entries} ɒǉ
	 * ܂B
	 *
	 * @param name f[^
	 * @param values InspectionData ŕ\ꂽ̒l̗
	 */
	protected void add(String name, InspectionData values) {
		// append a new element to entries array
		extend_entries();

		// set this (name . values) dot-pair to the tail of array
		entries[entries.length - 1]	= new Datum(name, values);
	}
}
