/***********************************************************************
 * File: LogResource.java
 * 	(Extracted from
 *	   "$Id: LogResource.java,v 1.1 2004/06/02 13:24:21 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a LogResource utility class.
 *  (Refered Class: Log)
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package	my_util;

import	java.io.*;
import	java.util.Hashtable;

/**
 * <p>OۊǂVXe̊ǗsT|[gENXłB</p>
 * @author maoyam
 * @version 1.0
 * @see my_util.Log
 */
public class LogResource {
	static private Hashtable resources = new Hashtable();

	/** Oۊǂ鎑ւ̏o͐ PrintStream */
	protected PrintStream	out = null;
	/** Oۊǂ鎑ւ̏o͂ۂ̕GR[fBO̖O */
	protected String		encoding = null;
	/** ̃Oۊǐ掑gpĂ Log CX^X̐ */
	protected int			opened_cnt	= 0;


	/**
	 * RXgN^𒼐ڌĂяoƂ͂ł܂B<br>
	 * {@link #create} ŃOۊǐ掑̓o^s܂B
	 * @param path OۊǂVXeւ̃pXB
	 *             ݂̓t@Ĉ݃T|[g
	 */
	private LogResource(String path, String encoding) throws Exception {
		FileOutputStream fos =
							new FileOutputStream(new File(path), true);
												// append or create
		out	= (encoding != null)?
				new PrintStream(fos, true, encoding):
				new PrintStream(fos, true); // auto-flush, encoding
		opened_cnt	= 1;
		this.encoding	= encoding;
	}

	/**
	 * Oۊǐo^܂Bo^ɐƁAOۊǐւ̏o͗p
	 * PrintStream  append [h auto-flush [hŃI[v
	 * ܂B<br>
	 * w肳ꂽOۊǐ̃I[vɎsꍇAO܂B
	 * @param path OۊǂVXeւ̃pXB
	 *             ݂̓t@Ĉ݃T|[g
	 * @param encoding OۊǂVXe֏o͂ۂ
	 *             GR[fBO̖OB[JVXe
	 *             ftHgGR[fBOw肷ꍇ
	 *             null w肷
	 * @return <ul><li> null - OۊǐVXe̊Ǘ</li
	 *          ><li>null - Oۊǐ path  null 󕶎̏ꍇ</li
	 *          ></ul>
	 * @exception FileNotFoundException Oۊǐ悪fBNg
	 *              I[vłȂt@C̏ꍇ
	 * @exception SecurityException ݌ŃI[vłȂꍇ
	 * @exception UnsupportedExcodingException
	 *          w肳ꂽGR[fBOT|[gĂȂꍇ
	 * @exception Exception łɃI[vꂽOۊǐ PrintStream
	 *              ̕GR[fBO encoding Ŏw肳ꂽ̂
	 *              vĂȂꍇ
	 */
	static protected LogResource create(String path, String encoding)
													throws Exception {
		LogResource	result = null;

		if (path != null && path.length() != 0) {
			synchronized (resources) {
				result = (LogResource)(resources.get(path));
				if (result == null) {
					result	= new LogResource(path, encoding);
					resources.put(path, result);
				}
				else if ((result.encoding == null && encoding == null)
				|| (result.encoding != null && encoding != null
						&& result.encoding.compareTo(encoding) == 0)) {
					++result.opened_cnt;
				}
				else {
					throw new Exception("LogResource.create(" + path
										+ ", " + encoding
										+ "): encoding miss-matched "
										+ "(opened encoding: "
										+ result.encoding + ")"
										);
				}
			} // synchronized (resources)
		}

		return	result;
	}

	/**
	 * Oۊǐ̃VXeo^B̎gpĂ
	 * Log Ȃ΁Ao͐ PrintStream N[Y܂B
	 * @param path OۊǂVXeւ̃pXB
	 *             ݂̓t@Ĉ݃T|[g
	 */
	static protected void destroy(String path) {
		synchronized (resources) {
			LogResource res	= (LogResource)(resources.get(path));
			if ((res != null) && res.opened_cnt == 1) {
				res.out.close();
				resources.remove(path);
			}
			else {
				--res.opened_cnt;
			}
		} // synchronized (resources)
	}

	/**
	 * OۊǐƂĎgpĂ PrintStream ̐擾܂B
	 */
	static public int get_resource_cnt() {
		int	opened_resource_cnt = 0;

		synchronized (resources) {
			opened_resource_cnt	= resources.size();
		}

		return	opened_resource_cnt;
	}

	/**
	 * ɓo^ĂVXeǂ𔻒肵܂B
	 * @param path 肷VXeւ̃pX
	 * @return <ul><li>true o^Ăꍇ</li
	 *            ><li>false o^ĂȂꍇ邢̓VXe
	 *                 path  null ̏ꍇ</li
	 *            ></ul>
	 */
	static public boolean is_registered(String path) {
		boolean	result = false;

		if (path != null) {
			synchronized (resources) {
				result	= (resources.get(path) != null);
			}
		}

		return	result;
	}

	/**
	 * OۊǐVXe̕GR[fBO擾܂B
	 * @param path VXeւ̃pX
	 * @return <ul><li>null VXẽftHgGR[fBO
	 *                 ꍇ</li
	 *            ><li>󕶎 ("") pX͓o^ĂȂꍇ邢
	 *                 VXe path  null ̏ꍇ</li
	 *            ><li>LȊO GR[fBO
	 *            ></ul>
	 */
	static public String get_encoding(String path) {
		String	result = null;

		if (path != null) {
			synchronized (resources) {
				LogResource lr = (LogResource)(resources.get(path));
				if (lr != null) {
					result	= lr.encoding;
				}
				else {
					result	= "";
				}
			}
		}
		else {
			result	= "";
		}

		return	result;
	}
}
