/***********************************************************************
 * File: Utillity.java
 * 	(Extracted from
 *	   "$Id: Utillity.java,v 1.3 2004/06/28 14:59:15 maoyam Exp maoyam $")
 *
 * Abstracts:
 *  This Java source code implements a Utillity utility class.
 *  This class provides several useful class-methods, for the
 * my_util pakage.
 *
 * Copyright (C) 2004 Maoyam Tokyo, Japan (mailto:maoyam@mail.goo.ne.jp)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 **********************************************************************/

package	my_util;

import	java.io.*;
import	java.nio.*;
import	java.nio.channels.*;
import	java.util.*;

import my_util.TimeoutException;

/**
 * <p>my_util pbP[Ŵ߂̃[eBeBENXB</p>
 * @author maoyam
 * @version 1.0
 */
public class Utillity {
	/**
	 * ̃NX̃CX^X͍쐬ł܂
	 */
	private Utillity() { }

	/**
	 * InputStream  OutputStream ֕GR[fBOϊ
	 * f[^e]܂B
	 * @param is ͑ InputStream
	 * @param in_encoding ͑̕GR[fBO
	 * @param os o͑ OutputStream
	 * @param out_encoding o͑̕GR[fBO
	 * @param autoFlush o͑ OutputStream IɃtbV邩
	 *                  ǂw
	 * @exception NullPointerException is 邢 os  null ̏ꍇ
	 * @exception UnsupportedEncodingException
	 *                                 in_encoding 邢 out_encoding
	 *                                 T|[gĂȂ
	 *                                 GR[fBȌꍇ
	 * @exception IOException o͏ɃG[ꍇ
	 */
	static public void encoding_stream2stream(InputStream is
								, String in_encoding
								, OutputStream os
								, String out_encoding
								, boolean autoFlush
								) throws UnsupportedEncodingException
										, IOException
										, NullPointerException
								{
		if (is == null || os == null) {
			Exception e = new Exception();
			StackTraceElement[] ste = e.getStackTrace();

			throw new NullPointerException(ste[1].getClassName() + "."
											+ ste[1].getMethodName()
											+ ": "
											+ ((is == null)?
													"Input": "Output")
											+ "Stream is null."
										);
		}

		BufferedReader	in = new BufferedReader(
									new InputStreamReader(
											is
											, ((in_encoding == null)?
												"JISAutoDetected":
												in_encoding)
											)
									);
		PrintStream	out = (out_encoding == null)?
						new PrintStream(os):
						new PrintStream(os, autoFlush, out_encoding);

		String line;
		while ((line = in.readLine()) != null) {
			out.println(line);
		}

		out.close();
		in.close();
	}

	/**
	 * ^CAEgĎJnVXe_ɂāA
	 * ݃VXe^CAEg܂ł̎c莞Ԃ
	 * ~bxŋ߂܂B
	 * @param start_millis ^CAEgĎJnVXe (msec)
	 * @param timeout ^CAEg (msec)
	 * @return <ul><li>1 ȏ -- ^CAEg܂ł̎c莞 (msec)</li
	 *            ><li>1  -- Ƀ^CAEgĂꍇ</li
	 *            ></ul>
	 * @exception TimeoutException ^CAEgꍇ
	 */
	static public long check_timeout(long start_millis, long timeout)
											throws TimeoutException {
		long	true_to = timeout;
		if (timeout > 0) {
			long now = System.currentTimeMillis();
			if (now != start_millis) {
				true_to -=
						((start_millis < now)?
							(now - start_millis):
							(Long.MAX_VALUE - start_millis + now + 1)
						);
			}
			if (true_to <= 0) {
				Exception e = new Exception();
				StackTraceElement[] ste = e.getStackTrace();

				throw new TimeoutException(ste[1].getClassName() + "."
												+ ste[1].getMethodName()
											, timeout
											);
			}
		}

		return	true_to;
	}

	/**
	 * OX^bNEg[XtH[}bg܂B
	 * @param sb tH[}bgʂ append  StringBuffer
	 * @param e O
	 * @return tH[}bgOX^bNEg[X StringBuffer
	 */
	static public StringBuffer format_exception_info(StringBuffer sb
													, Exception e
													) {
		// check the StringBuffer is null?
		if (sb == null) {
			sb	= new StringBuffer(4096); // make a new StringBuffer
		}

		// append the message of this exception
		sb.append("\"").append(e.getMessage()).append("\" ");

		// append the stack trace of this exception
		StackTraceElement[] ste = e.getStackTrace();
		for (int i = 0; i < ste.length; ++i) {
			sb.append("[").append(i + 1).append("] ");
			sb.append(ste[i]).append(" ");
		}

		return	sb; // returns the StringBuffer that is updated
	}

	/**
	 * ~bx̌oߎԂtH[}bg`
	 * dd days HH hours MM min SS.sss sec  StringBuffer ɃtH[}bg
	 * ܂B
	 *
	 * @param sb oߎԌ`o͂ StringBuffer
	 * @param msec ~bx̌oߎ
	 * @return oߎԌ`
	 */
	static public StringBuffer format_elapsed_milli_sec(StringBuffer sb
														, long msec
														) {
		if (sb == null) {
			sb = new StringBuffer(4096);
		}

		if (msec < 0) {
			sb.append("(negative elapsed time: ")
										.append(Long.toString(msec));
		}
		else {
			long v = msec / (24 * 60 * 60 * 1000);
			msec	%= (24 * 60 * 60 * 1000);
			if (v > 0) {
				sb.append(Long.toString(v))
						.append(" day").append(((v > 1)? "s ": " "));
			}
			v	= msec / (60 * 60 * 1000);
			msec %= (60 * 60 * 1000);
			if (v > 0) {
				sb.append(Long.toString(v))
						.append(" hour").append(((v > 1)? "s ": " "));
			}
			v	= msec / (60 * 1000);
			msec %= (60 * 1000);
			if (v > 0) {
				sb.append(Long.toString(v))
						.append(" min").append(((v > 1)? "s ": " "));
			}
			v	= msec / 1000;
			msec %= 1000;
			sb.append(Long.toString(v)).append(".")
						.append(((msec < 10)?		"00":
									(msec < 100)?	"0":
													""))
						.append(Long.toString(msec))
						.append(" sec").append(((v > 1)? "s ": " "));
		}

		return sb;
	}

	/**
	 * ~bx̃VXeEG|bŇoߎԂ` 
	 * yyyy/mm/dd HH:MM:SS.sss  StringBuffer ɃtH[}bg܂B
	 *
	 * @param sb `o͂ StringBuffer
	 * @param msec ~bx̃VXeEG|bŇoߎ
	 * @return `
	 */
	static public StringBuffer format_milli_sec(StringBuffer sb
												, long msec
												) {
		if (sb == null) {
			sb	= new StringBuffer("");
		}

		Calendar now = Calendar.getInstance();
		now.setTime(new Date(msec));
		int	v = now.get(now.YEAR);
		if (v < 10) sb.append("000");
		else if (v < 100) sb.append("00");
		else if (v < 1000) sb.append("0");
		sb.append(v);
		sb.append("/");
		v = now.get(now.MONTH) + 1;
		if (v < 10) sb.append("0");
		sb.append(v);
		sb.append("/");
		v = now.get(now.DATE);
		if (v < 10) sb.append("0");
		sb.append(v);
		sb.append(" ");
		v = now.get(now.HOUR_OF_DAY);
		if (v < 10) sb.append("0");
		sb.append(v);
		sb.append(":");
		v = now.get(now.MINUTE);
		if (v < 10) sb.append("0");
		sb.append(v);
		sb.append(":");
		v = now.get(now.SECOND);
		if (v < 10) sb.append("0");
		sb.append(v);
		sb.append(".");
		msec %= 1000;
		if (msec < 10) sb.append("00");
		else if (msec < 100) sb.append("0");
		sb.append(msec);

		return	sb;
	}

	/**
	 * Q MappedByteBuffer ̓eƂ𔻒肵܂B
	 *
	 * @param mbb0 Pڂ MappedByteBuffer
	 * @param mbb1 Qڂ MappedByteBuffer
	 * @return <ul><li>true -- MappedByteBuffer ꍇ</li
	 *            ><li>false -- MappedByteBuffer Ȃꍇ</li
	 *            ></ul>
	 * @exception IllegalArgumentException
	 *                    ꂩ MappedByteBuffer  null ̏ꍇ
	 * @exception Exception t@Co͂ŗOꍇB
	 *                     java.nio.MappedByteBuffer QƂ邱ƁB
	 */
	static public boolean equals_file_contents(MappedByteBuffer mbb0
												, MappedByteBuffer mbb1
												) throws Exception {
		if (mbb0 == null) {
			throw new IllegalArgumentException("mbb0 is null.");
		}
		if (mbb1 == null) {
			throw new IllegalArgumentException("mbb1 is null.");
		}

		try {
			byte[] b0 = new byte[4096], b1 = new byte[4096];
			while (true) {
				mbb0.get(b0, 0, b0.length);
				mbb1.get(b1, 0, b1.length);
				if (!Arrays.equals(b0, b1)) {
					return	 false; // not same contents
				}
			}
		} catch (BufferUnderflowException bue) { ; /* ignore this */ }
		try {
			while (true) {
				if (mbb0.get() != mbb1.get()) {
					return	 false; // not same contents
				}
			}
		} catch (BufferUnderflowException bue) { ; /* compared all */ }

		return	true; // the same contents
	}

	/**
	 * Q̃t@C̓Xg[̓eƂ𔻒肵܂B
	 *
	 * @param fis0 Pڂ̃t@C̓Xg[
	 * @param fis1 Qڂ̃t@C̓Xg[
	 * @return <ul><li>true -- t@Ceꍇ</li
	 *            ><li>false -- t@CeȂꍇ</li
	 *            ></ul>
	 * @exception IllegalArgumentException
	 *                    ꂩ̃t@C̓Xg[ null ̏ꍇ
	 * @exception Exception t@Co͂ŗOꍇB
	 *                     java.io.FileInputStream  
	 *                     java.nio.MappedByteBuffer QƂ邱ƁB
	 */
	static public boolean equals_file_contents(FileInputStream fis0
												, FileInputStream fis1
												) throws Exception {
		if (fis0 == null) {
			throw new IllegalArgumentException("fis0 is null.");
		}
		if (fis1 == null) {
			throw new IllegalArgumentException("fis1 is null.");
		}

		FileChannel fc0 = fis0.getChannel();
		FileChannel fc1 = fis1.getChannel();
		long	sz0 = fc0.size(), sz1 = fc1.size();

		if (sz0 != sz1) {
			return false; // not same size
		}

		return equals_file_contents(
						  fc0.map(FileChannel.MapMode.READ_ONLY, 0, sz0)
						, fc1.map(FileChannel.MapMode.READ_ONLY, 0, sz1)
						);
	}

	/**
	 * Q̃t@C̓eƂ𔻒肵܂B
	 *
	 * @param file0 Pڂ̃t@C
	 * @param file1 Qڂ̃t@C
	 * @return <ul><li>true -- t@Ceꍇ</li
	 *            ><li>false -- t@CeȂꍇ</li
	 *            ></ul>
	 * @exception IllegalArgumentException 1) ꂩ̃t@C null
	 *                                      ̏ꍇ
	 *                                     2) ꂩ̃t@C
	 *                                      ǂ݉\t@C
	 *                                      Ȃꍇ
	 * @exception Exception t@Co͂ŗOꍇB
	 *                     java.io.FileInputStream  
	 *                     java.nio.MappedByteBuffer QƂ邱ƁB
	 */
	static public boolean equals_file_contents(File file0
												, File file1
												) throws Exception {
		if (file0 == null) {
			throw new IllegalArgumentException("file0 is null.");
		}
		if (file1 == null) {
			throw new IllegalArgumentException("file1 is null.");
		}
		if (!file0.exists() || !file0.isFile() || !file0.canRead()) {
			throw new IllegalArgumentException(file0.getPath()
											+ " is not a readable file."
									);
		}
		if (!file1.exists() || !file1.isFile() || !file1.canRead()) {
			throw new IllegalArgumentException(file0.getPath()
											+ " is not a readable file."
									);
		}

		return	equals_file_contents(new FileInputStream(file0)
									, new FileInputStream(file1)
									);
	}

	/**
	 * Q̃t@CEpX̓eƂ𔻒肵܂B
	 *
	 * @param path0 Pڂ̃t@CEpX
	 * @param path1 Qڂ̃t@CEpX
	 * @return <ul><li>true -- t@Ceꍇ</li
	 *            ><li>false -- t@CeȂꍇ</li
	 *            ></ul>
	 * @exception IllegalArgumentException 1) ꂩ̃t@CEpX
	 *                                      null ̏ꍇ
	 *                                     2) ꂩ̃t@CEpX
	 *                                      ǂ݉\t@C
	 *                                      Ȃꍇ
	 * @exception Exception t@Co͂ŗOꍇB
	 *                     java.io.FileInputStream  
	 *                     java.nio.MappedByteBuffer QƂ邱ƁB
	 */
	static public boolean equals_file_contents(String path0
												, String path1
												) throws Exception {
		if (path0 == null) {
			throw new IllegalArgumentException("path0 is null.");
		}
		if (path1 == null) {
			throw new IllegalArgumentException("path1 is null.");
		}

		return	equals_file_contents(new File(path0), new File(path1));
	}
}
